function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

var b = [
	{
		display: "Border",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border",
		valuetemplate: "{0}px {1} {2}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "number",
				label: "Width",
				min: "0",
				max: "100",
				"default": "1"
			},
			{
				type: "select",
				label: "Pattern",
				"default": "none",
				options: [
					{
						name: "Solid",
						value: "solid"
					},
					{
						name: "Dotted",
						value: "dotted"
					},
					{
						name: "Dashed",
						value: "dashed"
					},
					{
						name: "Double",
						value: "double"
					},
					{
						name: "Groove",
						value: "groove"
					},
					{
						name: "Ridge",
						value: "ridge"
					},
					{
						name: "Inset",
						value: "inset"
					},
					{
						name: "Outset",
						value: "outset"
					},
					{
						name: "Initial",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Hidden",
						value: "hidden"
					}
				]
			},
			{
				type: "color",
				label: "Color",
				"default": "#000"
			}
		]
	},
	{
		display: "Border Radius (Custom)",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-radius",
		valuetemplate: "{0}{1}",
		categories: [
			"border"
		],
		tags: " presentation",
		controls: [
			{
				type: "range",
				label: "Amount",
				min: "0",
				max: "100",
				"default": "0px"
			},
			{
				type: "select",
				label: "Unit",
				"default": "px",
				options: [
					{
						name: "Pixels",
						value: "px"
					},
					{
						name: "Percentage",
						value: "%"
					}
				]
			}
		]
	},
	{
		display: "Color: Border",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Color: Border : Left",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-left-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Color: Border: Right",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-right-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Color: Border: Top",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-top-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Color: Border : Bottom",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-bottom-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Border : Bottom",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-bottom",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color, presentation",
		controls: [
			{
				type: "range",
				label: "Width",
				min: "0",
				max: "100",
				"default": "1",
				suffix: "px"
			},
			{
				type: "select",
				label: "Pattern",
				"default": "none",
				options: [
					{
						name: "Solid",
						value: "solid"
					},
					{
						name: "Dotted",
						value: "dotted"
					},
					{
						name: "Dashed",
						value: "dashed"
					},
					{
						name: "Double",
						value: "double"
					},
					{
						name: "Groove",
						value: "groove"
					},
					{
						name: "Ridge",
						value: "ridge"
					},
					{
						name: "Inset",
						value: "inset"
					},
					{
						name: "Outset",
						value: "outset"
					},
					{
						name: "Initial",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Hidden",
						value: "hidden"
					}
				]
			},
			{
				type: "color",
				label: "Color",
				"default": "#000"
			}
		]
	},
	{
		display: "Border Radius (Custom)",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-radius",
		valuetemplate: "{0}{1}",
		categories: [
			"border"
		],
		tags: "presentation",
		controls: [
			{
				type: "range",
				label: "Amount",
				min: "0",
				max: "100",
				"default": "1"
			},
			{
				type: "select",
				label: "Unit",
				"default": "px",
				options: [
					{
						name: "Pixels",
						value: "px"
					},
					{
						name: "Percentage",
						value: "%"
					}
				]
			}
		]
	}
];

var c = [
	{
		display: "Table Caption",
		description: "Specifies the placement of a table caption",
		link: "https://www.w3schools.com/cssref/pr_tab_caption-side.asp",
		propertyName: "caption-side",
		valuetemplate: "{0}",
		categories: [
			"caption",
			"table"
		],
		tags: "all, table",
		controls: [
			{
				type: "select",
				"default": "top",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Top",
						value: "top"
					},
					{
						name: "Bottom",
						value: "bottom"
					}
				]
			}
		]
	},
	{
		display: "Caret Color",
		description: "Specifies the color of the cursor (caret) in inputs, textareas, or any element that is editable",
		link: "https://www.w3schools.com/cssref/css3_pr_caret-color.asp",
		propertyName: "caret-color",
		valuetemplate: "{0}",
		categories: [
			"color"
		],
		tags: "color",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Color",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "color",
									label: "Custom Color"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Charset",
		description: "Specifies the character encoding to use",
		link: "https://www.w3schools.com/cssref/pr_charset_rule.asp",
		propertyName: "@charset",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "meta",
		controls: [
			{
				type: "text",
				"default": ""
			}
		]
	},
	{
		display: "Clear",
		description: "Specifies what should happen with the element that is next to a floating element",
		link: "https://www.w3schools.com/cssref/pr_class_clear.asp",
		propertyName: "clear",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "meta",
		controls: [
			{
				type: "select",
				label: "Clear Property",
				"default": "none",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "None",
						value: "None"
					},
					{
						name: "Left",
						value: "left"
					},
					{
						name: "Right",
						value: "right"
					},
					{
						name: "Bottom",
						value: "bottom"
					}
				]
			}
		]
	},
	{
		display: "Clip",
		description: "Clips an absolutely positioned element",
		link: "https://www.w3schools.com/cssref/pr_pos_clip.asp",
		propertyName: "clip",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "meta",
		controls: [
			{
				type: "select",
				label: "Clip",
				"default": "auto",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Shape",
						valuetemplate: "shape({0} {1} {2} {3})",
						value: {
							controls: [
								{
									type: "number",
									label: "Top"
								},
								{
									type: "number",
									label: "Right"
								},
								{
									type: "number",
									label: "Bottom"
								},
								{
									type: "number",
									label: "Left"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Color",
		description: "Set the text-color for different elements",
		link: "https://www.w3schools.com/cssref/pr_text_color.asp",
		propertyName: "color",
		valuetemplate: "{0}",
		categories: [
			"color"
		],
		tags: "color",
		controls: [
			{
				type: "select",
				label: "Value",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "color",
									label: "Custom Color"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Column Count",
		description: "Specifies the number of columns an element should be divided into",
		link: "https://www.w3schools.com/cssref/css3_pr_column-count.asp",
		propertyName: "column-count",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				defaukt: "auto",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "number",
									label: "Count"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Column Fills",
		description: "Specifies how to fill columns, balanced or not",
		link: "https://www.w3schools.com/cssref/css3_pr_column-fill.asp",
		propertyName: "column-fill",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "balance",
				options: [
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Balance",
						value: "balance"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Gap",
		description: "Specifies the gap between the columns",
		link: "https://www.w3schools.com/cssref/css3_pr_column-gap.asp",
		propertyName: "column-gap",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "normal",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Gap(in px)"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Rule",
		description: "Container column rule",
		link: "https://www.w3schools.com/cssref/css3_pr_column-rule.asp",
		propertyName: "column-rule",
		valuetemplate: "{0} {1} {2}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Width",
				"default": "medium",
				link: "https://www.w3schools.com/cssref/css3_pr_column-rule-width.asp",
				description: "Specifies the width of the rule between columns",
				options: [
					{
						name: "Medium",
						value: "medium"
					},
					{
						name: "Thin",
						value: "thin"
					},
					{
						name: "Thick",
						value: "thick"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Custom Width"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			},
			{
				type: "select",
				label: "Styles",
				description: "Specifies the style of the rule between columns",
				link: "https://www.w3schools.com/cssref/css3_pr_column-rule-style.asp",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "Hidden",
						value: "hidden"
					},
					{
						name: "Dotted",
						value: "dotted"
					},
					{
						name: "Dashed",
						value: "dashed"
					},
					{
						name: "Solid",
						value: "solid"
					},
					{
						name: "Double",
						value: "double"
					},
					{
						name: "Groove",
						value: "groove"
					},
					{
						name: "Ridge",
						value: "ridge"
					},
					{
						name: "Inset",
						value: "inset"
					},
					{
						name: "Outset",
						value: "outset"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			},
			{
				type: "select",
				label: "Color",
				"default": "inherit",
				description: "Specifies the color of the rule between columns",
				link: "https://www.w3schools.com/cssref/css3_pr_column-rule-color.asp",
				options: [
					{
						name: "Custom",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "color",
									label: "Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			},
			{
				name: "Default value",
				value: "initial"
			},
			{
				name: "Inherit from parent",
				value: "inherit"
			}
		]
	},
	{
		display: "Column Rule: Color",
		link: "https://www.w3schools.com/cssref/css3_pr_column-rule-width.asp",
		description: "Specifies the width of the rule between columns",
		propertyName: "column-rule-color",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Color",
				"default": "inherit",
				description: "Specifies the color of the rule between columns",
				link: "https://www.w3schools.com/cssref/css3_pr_column-rule-color.asp",
				options: [
					{
						name: "Custom",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "color",
									label: "Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Rule: Style",
		description: "Specifies the style of the rule between columns",
		link: "https://www.w3schools.com/cssref/css3_pr_column-rule-style.asp",
		propertyName: "column-rule-style",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Styles",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "Hidden",
						value: "hidden"
					},
					{
						name: "Dotted",
						value: "dotted"
					},
					{
						name: "Dashed",
						value: "dashed"
					},
					{
						name: "Solid",
						value: "solid"
					},
					{
						name: "Double",
						value: "double"
					},
					{
						name: "Groove",
						value: "groove"
					},
					{
						name: "Ridge",
						value: "ridge"
					},
					{
						name: "Inset",
						value: "inset"
					},
					{
						name: "Outset",
						value: "outset"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Rule: Width",
		link: "https://www.w3schools.com/cssref/css3_pr_column-rule-width.asp",
		description: "Specifies the width of the rule between columns",
		propertyName: "column-rule-width",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Width",
				"default": "medium",
				options: [
					{
						name: "Medium",
						value: "medium"
					},
					{
						name: "Thin",
						value: "thin"
					},
					{
						name: "Thick",
						value: "thick"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Custom Width"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Span",
		link: "https://www.w3schools.com/cssref/css3_pr_column-span.asp",
		description: "Specifies how many columns an element should span across",
		propertyName: "column-span",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Width",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "All",
						value: "all"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Width",
		link: "https://www.w3schools.com/cssref/css3_pr_column-width.asp",
		description: "Specifies the column width",
		propertyName: "column-width",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Width",
				"default": "none",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Length"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Columns",
		link: "https://www.w3schools.com/cssref/css3_pr_columns.asp",
		description: "Specifies the column definition",
		propertyName: "columns",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Column Width",
				"default": "auto",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px {1}",
						value: {
							controls: [
								{
									type: "number",
									label: "Custom Width"
								},
								{
									type: "number",
									label: "Column Count"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Content",
		link: "https://www.w3schools.com/cssref/pr_gen_content.asp",
		description: "Used with the :before and :after pseudo-elements, to insert generated content",
		propertyName: "content",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "normal",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Counter",
						valuetemplate: "counter({0})",
						value: {
							controls: [
								{
									type: "number",
									label: "Counter Value"
								}
							]
						}
					},
					{
						name: "Attribute",
						valuetemplate: "attr({0})",
						value: {
							controls: [
								{
									type: "text",
									label: "Attribute Value"
								}
							]
						}
					},
					{
						name: "String",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "text",
									label: "String Value"
								}
							]
						}
					},
					{
						name: "Open Quote",
						value: "open-quote"
					},
					{
						name: "Close Quote",
						value: "close-quote"
					},
					{
						name: "No Open Quote",
						value: "no-open-quote"
					},
					{
						name: "No Close Quote",
						value: "no-close-quote"
					},
					{
						name: "URL",
						valuetemplate: "url({0})",
						value: {
							controls: [
								{
									type: "text",
									label: "URL Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Counter Increment",
		link: "https://www.w3schools.com/cssref/pr_gen_counter-increment.asp",
		description: "Increases or decreases the value of one or more CSS counters",
		propertyName: "counter-increment",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "Identifier",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "text",
									label: "ID Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Counter Reset",
		link: "https://www.w3schools.com/cssref/pr_gen_counter-reset.asp",
		description: "Creates or resets one or more CSS counters",
		propertyName: "counter-reset",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "Identifier",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "text",
									label: "ID Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Cursor",
		link: "https://www.w3schools.com/cssref/playit.asp?filename=playcss_cursor&preval=alias",
		description: "Specifies the mouse cursor to be displayed when pointing over an element",
		propertyName: "cursor",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "meta",
		controls: [
			{
				type: "select",
				label: "Cursor Type",
				"default": "auto",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "Alias",
						value: "alias"
					},
					{
						name: "Cell",
						value: "cell"
					},
					{
						name: "Context Menu",
						value: "context-menu"
					},
					{
						name: "Column Resize",
						value: "col-resize"
					},
					{
						name: "Copy",
						value: "copy"
					},
					{
						name: "Crosshair",
						value: "crosshair"
					},
					{
						name: "Default",
						value: "default"
					},
					{
						name: "Edge Resize",
						value: "e-resize"
					},
					{
						name: "Bidirectional Edge Resize",
						value: "ew-resize"
					},
					{
						name: "Grab-able",
						value: "grab"
					},
					{
						name: "Grabbed",
						value: "grabbing"
					},
					{
						name: "Help",
						value: "help"
					},
					{
						name: "Move Edge",
						value: "move"
					},
					{
						name: "Resize towards North",
						value: "n-resize"
					},
					{
						name: "Resize towards North East",
						value: "ne-resize"
					},
					{
						name: "Resize towards North South East West",
						value: "nesw-resize"
					},
					{
						name: "Resize towards North South",
						value: "ns-resize"
					},
					{
						name: "Resize towards North West",
						value: "nw-resize"
					},
					{
						name: "Resize towards North West South East",
						value: "nwse-resize"
					},
					{
						name: "Cannot drop dragged item",
						value: "no-drop"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Action not allowed",
						value: "not-allowed"
					},
					{
						name: "Pointer",
						value: "pointer"
					},
					{
						name: "Loading / Progress",
						value: "progress"
					},
					{
						name: "Row Resize",
						value: "row-resize"
					},
					{
						name: "Resize towards South",
						value: "s-resize"
					},
					{
						name: "Resize towards South East",
						value: "se-resize"
					},
					{
						name: "Resize towards South West",
						value: "sw-resize"
					},
					{
						name: "Text selection",
						value: "text"
					},
					{
						name: "URL (Custom Cursor)",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "text",
									label: "Coma Separated"
								}
							]
						}
					},
					{
						name: "Vertical text selection",
						value: "vertical-text"
					},
					{
						name: "Resize towards West",
						value: "w-resize"
					},
					{
						name: "Wait",
						value: "wait"
					},
					{
						name: "Zoom IN",
						value: "zoom-in"
					},
					{
						name: "Zoom Out",
						value: "zoom-out"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var d = [
	{
		display: "Direction",
		description: "Specifies the text direction/writing direction",
		link: "https://www.w3schools.com/cssref/pr_text_direction.asp",
		propertyName: "direction",
		valuetemplate: "{0}",
		categories: [
			"container",
			"text"
		],
		tags: "container,text",
		controls: [
			{
				type: "select",
				"default": "ltr",
				options: [
					{
						value: "ltr",
						name: "Left to right"
					},
					{
						value: "rtl",
						name: "Right to left"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Display",
		link: "https://www.w3schools.com/cssref/pr_class_display.asp",
		description: "Specifies how an element should be displayed",
		propertyName: "display",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "meta",
		controls: [
			{
				type: "select",
				label: "Cursor Type",
				"default": "auto",
				options: [
					{
						name: "Inline Display",
						value: "inline"
					},
					{
						name: "Block (New line)",
						value: "block"
					},
					{
						name: "Content Only",
						value: "contents"
					},
					{
						name: "Flexible container",
						value: "flex"
					},
					{
						name: "Inline Block",
						value: "inline-block"
					},
					{
						name: "Inline flex",
						value: "inline flex"
					},
					{
						name: "Inline grid",
						value: "inline-grid"
					},
					{
						name: "Inline table",
						value: "inline-table"
					},
					{
						name: "List item",
						value: "list-item"
					},
					{
						name: "Contextual block or inline",
						value: "run-in"
					},
					{
						name: "Table",
						value: "table"
					},
					{
						name: "Like Caption element",
						value: "table-caption"
					},
					{
						name: "Table column group",
						value: "table-column-group"
					},
					{
						name: "Table header group",
						value: "table-header-group"
					},
					{
						name: "Table footer group",
						value: "table-footer-group"
					},
					{
						name: "Table row group",
						value: "table-row-group"
					},
					{
						name: "Table cell",
						value: "table-cell"
					},
					{
						name: "Table column",
						value: "table-column"
					},
					{
						name: "Table row",
						value: "table-row"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var j = [
	{
		display: "Justify Content Horizontally",
		description: "Specifies the alignment between the items inside a flexible container when the items do not use all available space",
		link: "https://www.w3schools.com/cssref/css3_pr_justify-content.asp",
		propertyName: "justify-content",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "flex, alignment",
		controls: [
			{
				type: "select",
				"default": "flex-start",
				label: "Value",
				options: [
					{
						name: "Start",
						value: "flex-start"
					},
					{
						name: "End",
						value: "flex-end"
					},
					{
						name: "Center",
						value: "center"
					},
					{
						name: "Space Between",
						value: "space-between"
					},
					{
						name: "Space Around",
						value: "space-around"
					},
					{
						name: "Default Value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var u = [
	{
		display: "Unicode Bidi",
		description: "Used together with the direction property to set or return whether the text should be overridden to support multiple languages in the same document.",
		link: "https://www.w3schools.com/cssref/pr_text_unicode-bidi.asp",
		propertyName: "unicode-bidi",
		valuetemplate: "{0}",
		categories: [
			"Misc"
		],
		tags: "direction",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Embed",
						value: "embed"
					},
					{
						name: "Override",
						value: "bidi-override"
					},
					{
						name: "isolate",
						value: "isolate"
					},
					{
						name: "Isolate Ooverride",
						value: "isolate-override"
					},
					{
						name: "Plaintext",
						value: "plaintext"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "User Select",
		description: "Specifies whether the text of an element can be selected.",
		link: "https://www.w3schools.com/cssref/css3_pr_user-select.asp",
		propertyName: "user-select",
		valuetemplate: "{0}",
		categories: [
			"Misc"
		],
		tags: "selection",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Value",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Text",
						value: "text"
					},
					{
						name: "All",
						value: "all"
					}
				]
			}
		]
	}
];

var v = [
	{
		display: "Vertical Align",
		description: "Sets the vertical alignment of an element",
		link: "https://www.w3schools.com/cssref/pr_pos_vertical-align.asp",
		propertyName: "vertical-align",
		valuetemplate: "{0}",
		categories: [
			"alignment",
			"layout",
			"position"
		],
		tags: "alignment, layout, position",
		controls: [
			{
				type: "select",
				"default": "baseline",
				label: "Value",
				options: [
					{
						name: "Align to baseline of container",
						value: "baseline"
					},
					{
						name: "Custom",
						valuetemplate: "{0}{1}",
						value: {
							controls: [
								{
									type: "number",
									label: "Amount",
									"default": "0"
								},
								{
									type: "select",
									label: "Unit",
									"default": "px",
									options: [
										{
											name: "Pixels",
											value: "px"
										},
										{
											name: "Percentage",
											value: "%"
										}
									]
								}
							]
						}
					},
					{
						name: "Align to subscript baseline of container",
						value: "sub"
					},
					{
						name: "Align to superscript baseline of container",
						value: "super"
					},
					{
						name: "Align to top of container",
						value: "top"
					},
					{
						name: "Align to top of the container element's font",
						value: "text-top"
					},
					{
						name: "Align to middle of container",
						value: "middle"
					},
					{
						name: "Align to bottom of container",
						value: "bottom"
					},
					{
						name: "Align to bottom of the container element's font",
						value: "text-bottom"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Visibility",
		description: "Specifies whether or not an element is visible",
		link: "https://www.w3schools.com/cssref/pr_class_visibility.asp",
		propertyName: "visibility",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				"default": "visible",
				label: "Value",
				options: [
					{
						name: "Make element visible",
						value: "visible"
					},
					{
						name: "Make element hidden",
						value: "hidden"
					},
					{
						name: "Collapse table rows and columns",
						value: "collapse"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var w = [
	{
		display: "White Space",
		description: "Specifies how white-space inside an element is handled",
		link: "https://www.w3schools.com/cssref/pr_text_white-space.asp",
		propertyName: "white-space",
		valuetemplate: "{0}",
		categories: [
			"container",
			"text"
		],
		tags: "container,text",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "No Wrap",
						value: "nowrap"
					},
					{
						name: "Whitespace preserved and wraps on line breaks",
						value: "pre"
					},
					{
						name: "Whitespace preserved and collapse on single whitespace",
						value: "pre-line"
					},
					{
						name: "Whitespace preserved and wraps when necessary",
						value: "pre-wrap"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Width",
		description: "Specifies the width of an element",
		link: "https://www.w3schools.com/cssref/pr_dim_width.asp",
		propertyName: "width",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Value",
				options: [
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Length"
								}
							]
						}
					},
					{
						name: "Percentage",
						value: "%"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Word Break",
		description: "Specifies how words should break when reaching the end of a line",
		link: "https://www.w3schools.com/cssref/css3_pr_word-break.asp",
		propertyName: "word-break",
		valuetemplate: "{0}",
		categories: [
			"container",
			"word"
		],
		tags: "container,word",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Break All",
						value: "break-all"
					},
					{
						name: "Keep All",
						value: "keep-all"
					},
					{
						name: "Break Word",
						value: "break-word"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Word Spacing",
		description: "Specifies the white space between words",
		link: "https://www.w3schools.com/cssref/pr_text_word-spacing.asp",
		propertyName: "word-spacing",
		valuetemplate: "{0}",
		categories: [
			"container",
			"word"
		],
		tags: "container,word",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Length"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Word Wrap",
		description: "Allows long words to be able to be broken and wrap onto the next line",
		link: "https://www.w3schools.com/cssref/css3_pr_word-wrap.asp",
		propertyName: "word-wrap",
		valuetemplate: "{0}",
		categories: [
			"container",
			"word"
		],
		tags: "container,word",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Break Word",
						value: "break-word"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Writing Mode",
		description: "Specifies whether lines of text are laid out horizontally or vertically",
		link: "https://www.w3schools.com/cssref/css3_pr_writing-mode.asp",
		propertyName: "writing-mode",
		valuetemplate: "{0}",
		categories: [
			"alignment",
			"layout",
			"position"
		],
		tags: "alignment,layout,position",
		controls: [
			{
				type: "select",
				"default": "horizontal-tb",
				label: "Value",
				options: [
					{
						name: "Horizontal content flow, top to bottom",
						value: "horizontal-tb"
					},
					{
						name: "Vertical content flow, right to left",
						value: "vertical-rl"
					},
					{
						name: "Vertical content flow, left to right",
						value: "vertical-lr"
					}
				]
			}
		]
	}
];

var z = [
	{
		display: "Stack Order",
		description: "Specifies the stack order of an element. Higher stack order gets priority over lower order in case of rendering.",
		link: "https://www.w3schools.com/cssref/pr_pos_z-index.asp",
		propertyName: "z-index",
		valuetemplate: "{0}",
		categories: [
			"container",
			"alignment"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Value",
				options: [
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "number",
									label: "Count"
								}
							]
						}
					}
				]
			}
		]
	}
];

var h = [
	{
		display: "Place the punctuation",
		description: "The hanging-punctuation property specifies whether a punctuation mark may be placed outside the line box at the start or at the end of a full line of text.",
		link: "https://www.w3schools.com/cssref/css3_pr_hanging-punctuation.asp",
		propertyName: "hanging-punctuation",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "punctuation, character, paragraph",
		controls: [
			{
				type: "select",
				"default": "none",
				label: "Value",
				options: [
					{
						name: "No Punctuation",
						value: "none"
					},
					{
						name: "At the First",
						value: "first"
					},
					{
						name: "At the Last",
						value: "last"
					},
					{
						name: "Allow at the End",
						value: "allow-end"
					},
					{
						name: "Force at the End",
						value: "force-end"
					},
					{
						name: "Default Value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Set the height",
		description: "The height property sets the height of an element. The height of an element does not include padding, borders, or margins!",
		link: "https://www.w3schools.com/cssref/pr_dim_height.asp",
		propertyName: "height",
		valuetemplate: "{0}",
		categories: [
			"misc",
			"layout",
			"container"
		],
		tags: "size, height, scale",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Value",
				options: [
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Default Value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							valuetemplate: "{0}{1}",
							controls: [
								{
									type: "number",
									label: "Value"
								},
								{
									type: "select",
									"default": "px",
									label: "Unit",
									options: [
										{
											name: "Pixels",
											value: "px"
										},
										{
											name: "Percent",
											value: "%"
										},
										{
											name: "Em",
											value: "em"
										},
										{
											name: "Rem",
											value: "rem"
										}
									]
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Allow hyphens to wrap text",
		description: "The hyphens property defines whether hyphenation is allowed to create more soft wrap opportunities within a line of text.",
		link: "https://www.w3schools.com/cssref/css3_pr_hanging-punctuation.asp",
		propertyName: "hyphens",
		valuetemplate: "{0}",
		categories: [
			"misc",
			"layout",
			"container"
		],
		tags: "wrap, layout",
		controls: [
			{
				type: "select",
				"default": "none",
				label: "Value",
				options: [
					{
						name: "No hypens",
						value: "none"
					},
					{
						name: "Words wrapped at '-' symbol",
						value: "manual"
					},
					{
						name: "Words wrapped automatically",
						value: "auto"
					},
					{
						name: "Default Value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var a = [
	{
		display: "Set all properties",
		description: "Resets all properties (except unicode-bidi and direction)",
		link: "https://www.w3schools.com/cssref/css3_pr_all.asp",
		propertyName: "all",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "all",
		controls: [
			{
				type: "select",
				"default": "none",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Unset",
						value: "unset"
					},
					{
						name: "None",
						value: ""
					}
				]
			}
		]
	},
	{
		display: "Align Content",
		description: "Specifies the alignment between the lines inside a flexible container when the items do not use all available space",
		link: "https://www.w3schools.com/cssref/css3_pr_align-content.asp",
		propertyName: "align-content",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "alignment,layout,position",
		controls: [
			{
				type: "select",
				"default": "stretch",
				label: "Alignment",
				options: [
					{
						name: "Stretch",
						value: "stretch"
					},
					{
						name: "Center",
						value: "center"
					},
					{
						name: "Start",
						value: "flex-start"
					},
					{
						name: "End",
						value: "flex-end"
					},
					{
						name: "Evenly Distributed",
						value: "space-between"
					},
					{
						name: "Evenly Distributed with padding",
						value: "space-around"
					},
					{
						name: "Evenly Distributed with padding both side",
						value: "space-evenly"
					},
					{
						name: "Default",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Align Items",
		description: "Specifies the alignment for items inside a flexible container",
		link: "https://www.w3schools.com/cssref/css3_pr_align-items.asp",
		propertyName: "align-items",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "alignment,layout,position",
		controls: [
			{
				type: "select",
				label: "Alignment",
				"default": "stretch",
				options: [
					{
						name: "Stretch",
						value: "stretch"
					},
					{
						name: "Center",
						value: "center"
					},
					{
						name: "Start",
						value: "flex-start"
					},
					{
						name: "End",
						value: "flex-end"
					},
					{
						name: "Align to baseline of container",
						value: "baseline"
					},
					{
						name: "Default",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Animation",
		description: "Prepares animation for selected object",
		propertyName: "animation",
		valuetemplate: "{0} {1} {2} {3} {4} {5} {6} {7}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				description: "Specifies the name of the keyframe you want to bind to the selector",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-name.asp",
				"default": "",
				label: "Animation Name",
				valuetemplate: "{0} ",
				options: [
					{
						name: "None",
						value: ""
					},
					{
						name: "Initial",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							valuetemplate: "{0}s",
							controls: [
								{
									type: "text",
									label: "Custom Name"
								}
							]
						}
					}
				]
			},
			{
				type: "select",
				"default": "",
				label: "Animation Duration",
				description: "Specifies how many seconds or milliseconds an animation takes to complete",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-duration.asp",
				valuetemplate: "{0}",
				options: [
					{
						name: "initial",
						value: "initial"
					},
					{
						name: "inherit",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "number",
									label: "In Seconds",
									valuetemplate: "{0} "
								}
							]
						}
					}
				]
			},
			{
				type: "select",
				"default": "ease",
				label: "Timing Function",
				description: "Specifies the speed curve of the animation",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-timing-function.asp",
				valuetemplate: "{0}",
				options: [
					{
						name: "Consistent Speed",
						value: "linear"
					},
					{
						name: "Slow-Fast-Slow",
						value: "ease"
					},
					{
						name: "Slow start",
						value: "ease-in"
					},
					{
						name: "Slow end",
						value: "ease-out"
					},
					{
						name: "Slow start | Slow end",
						value: "ease-in-out"
					},
					{
						name: "Start step with one",
						value: "step-start"
					},
					{
						name: "End step with one",
						value: "step-end"
					},
					{
						name: "Steps",
						valuetemplate: "steps({0},{1})",
						value: {
							controls: [
								{
									type: "number",
									label: "Steps"
								},
								{
									type: "select",
									label: "Position",
									options: [
										{
											name: "Start",
											value: "start"
										},
										{
											name: "End",
											value: "end"
										}
									]
								}
							]
						}
					},
					{
						name: "Cube",
						valuetemplate: "cubic-bezier({0},{1},{2},{3})",
						value: {
							controls: [
								{
									type: "number",
									label: "Step 1",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 2",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 3",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 4",
									min: "0",
									max: "100",
									multiplier: 0.01
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					}
				]
			},
			{
				type: "select",
				"default": "0",
				label: "Delay",
				description: "Specifies a delay before the animation will start",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-delay.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Custom",
						valuetemplate: "{0}s",
						value: {
							controls: [
								{
									type: "number",
									label: "Time(secs)"
								}
							]
						}
					}
				]
			},
			{
				type: "select",
				"default": "1",
				label: "Animation Repetition",
				description: "Specifies how many times an animation should be played",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-iteration-count.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Infinitely",
						value: "infinite"
					},
					{
						name: "Custom Repeat Count",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "number",
									label: "Repeat Count"
								}
							]
						}
					}
				]
			},
			{
				type: "select",
				"default": "normal",
				label: "Direction",
				description: "Specifies whether or not the animation should play in reverse on alternate cycles",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-direction.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Normal Direction",
						value: "normal"
					},
					{
						name: "Alternate Direction",
						value: "alternate"
					},
					{
						name: "Alternate Reverse Direction",
						value: "alternate-reverse"
					}
				]
			},
			{
				type: "select",
				"default": "none",
				label: "Animation Fill Mode",
				description: "Specifies what values are applied by the animation outside the time it is executing",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-fill-mode.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "No fille mode",
						value: "none"
					},
					{
						name: "From last keyframe",
						value: "forwards"
					},
					{
						name: "From first keyframe",
						value: "backwards"
					},
					{
						name: "Both from first and last",
						value: "both"
					}
				]
			},
			{
				type: "select",
				"default": "running",
				label: "Play State",
				description: "Specifies whether the animation is running or paused",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-play-state.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Paused",
						value: "paused"
					},
					{
						name: "Running",
						value: "running"
					}
				]
			}
		]
	},
	{
		display: "Self Align",
		description: "Specifies the alignment for selected items inside a flexible container",
		propertyName: "align-self",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "alignment,layout,position",
		controls: [
			{
				type: "select",
				"default": "auto",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "Stretched",
						value: "stretch"
					},
					{
						name: "Centered",
						value: "center"
					},
					{
						name: "Beginning of container",
						value: "flex-start"
					},
					{
						name: "End of container",
						value: "flex-end"
					},
					{
						name: "Baseline of container",
						value: "baseline"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Animation: Delay",
		description: "Specifies a delay for the start of an animation",
		propertyName: "animation-delay",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-delay.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "0",
				label: "Delay",
				description: "Specifies a delay before the animation will start",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-delay.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Custom",
						valuetemplate: "{0}s",
						value: {
							controls: [
								{
									type: "number",
									label: "Time(secs)"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Animation: Direction",
		description: "Specifies whether an animation should be played forwards, backwards or in alternate cycles",
		propertyName: "animation-direction",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-direction.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Direction",
				description: "Specifies whether or not the animation should play in reverse on alternate cycles",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-direction.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Normal Direction",
						value: "normal"
					},
					{
						name: "Alternate Direction",
						value: "alternate"
					},
					{
						name: "Alternate Reverse Direction",
						value: "alternate-reverse"
					}
				]
			}
		]
	},
	{
		display: "Animation: Duration",
		description: "Specifies how long an animation should take to complete one cycle",
		propertyName: "animation-duration",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-duration.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "",
				label: "Animation Duration",
				description: "Specifies how many seconds or milliseconds an animation takes to complete",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-duration.asp",
				valuetemplate: "{0}",
				options: [
					{
						name: "initial",
						value: "initial"
					},
					{
						name: "inherit",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "number",
									label: "In Seconds",
									valuetemplate: "{0}s"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Animation: Fill Mode",
		description: "Specifies a style for the element when the animation is not playing (before it starts, after it ends, or both)",
		propertyName: "animation-fill-mode",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-fill-mode.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "none",
				label: "Animation Fill Mode",
				description: "Specifies what values are applied by the animation outside the time it is executing",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-fill-mode.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "No fille mode",
						value: "none"
					},
					{
						name: "From last keyframe",
						value: "forwards"
					},
					{
						name: "From first keyframe",
						value: "backwards"
					},
					{
						name: "Both from first and last",
						value: "both"
					}
				]
			}
		]
	},
	{
		display: "Animation: Iteration",
		description: "Specifies the number of times an animation should be played",
		propertyName: "animation-iteration-count",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-iteration-count.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "1",
				label: "Animation Repetition",
				description: "Specifies how many times an animation should be played",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-iteration-count.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Infinitely",
						value: "infinite"
					},
					{
						name: "Custom Repeat Count",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "number",
									label: "Repeat Count"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Animation: Name",
		description: "Specifies a name for the @keyframes animation",
		propertyName: "animation-name",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-name.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				description: "Specifies the name of the keyframe you want to bind to the selector",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-name.asp",
				"default": "",
				label: "Animation Name",
				valuetemplate: "{0} ",
				options: [
					{
						name: "None",
						value: ""
					},
					{
						name: "Initial",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							valuetemplate: "{0}s",
							controls: [
								{
									type: "text",
									label: "Custom Name"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Animation: Play State",
		description: "Specifies whether the animation is running or paused",
		propertyName: "animation-play-state",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-play-state.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "running",
				label: "Play State",
				description: "Specifies whether the animation is running or paused",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-play-state.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Paused",
						value: "paused"
					},
					{
						name: "Running",
						value: "running"
					}
				]
			}
		]
	},
	{
		display: "Animation: Timing Function",
		description: "Specifies the speed curve of an animation",
		propertyName: "animation-timing-function",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-timing-function.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "ease",
				label: "Timing Function",
				description: "Specifies the speed curve of the animation",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-timing-function.asp",
				valuetemplate: "{0}",
				options: [
					{
						name: "Consistent Speed",
						value: "linear"
					},
					{
						name: "Slow-Fast-Slow",
						value: "ease"
					},
					{
						name: "Slow start",
						value: "ease-in"
					},
					{
						name: "Slow end",
						value: "ease-out"
					},
					{
						name: "Slow start | Slow end",
						value: "ease-in-out"
					},
					{
						name: "Start step with one",
						value: "step-start"
					},
					{
						name: "End step with one",
						value: "step-end"
					},
					{
						name: "Steps",
						valuetemplate: "steps({0},{1})",
						value: {
							controls: [
								{
									type: "number",
									label: "Steps"
								},
								{
									type: "select",
									label: "Position",
									options: [
										{
											name: "Start",
											value: "start"
										},
										{
											name: "End",
											value: "end"
										}
									]
								}
							]
						}
					},
					{
						name: "Cube",
						valuetemplate: "cubic-bezier({0},{1},{2},{3})",
						value: {
							controls: [
								{
									type: "number",
									label: "Step 1",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 2",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 3",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 4",
									min: "0",
									max: "100",
									multiplier: 0.01
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var Templates = a.concat(b, c, d, h, j, u, v, w, z);

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15, _templateObject16, _templateObject17;
var fadeIn = styled.keyframes(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["\n  0% {\n    opacity: 0;\n  }\n  100% {\n    opacity: 100%;\n  }\n"])));
var CBSimpleButton = styled__default.input(_templateObject2 || (_templateObject2 = _taggedTemplateLiteralLoose(["\n  padding: 8px;\n  background-color: transparent;\n  border: none;\n  border-radius: 3px;\n  letter-spacing: 0.2em;\n  transition: all 0.2s cubic-bezier(0.4, 0, 0.2, 1);\n  cursor: pointer;\n  border: 1px solid ", ";\n  color: ", ";\n  display: block;\n  &:hover {\n    /* letter-spacing: 0.8em; */\n    border-left: 10px solid ", ";\n  }\n"])), function (_ref) {
  var theme = _ref.theme;
  return theme.colors.button.borderColor;
}, function (_ref2) {
  var theme = _ref2.theme;
  return theme.colors.color;
}, function (_ref3) {
  var theme = _ref3.theme;
  return theme.colors.button.borderColor;
});
var CBAccordion = styled__default.div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteralLoose(["\n  color: ", ";\n  > div > div:first-of-type {\n    padding: 1em;\n    color: ", ";\n    text-transform: uppercase;\n    user-select: none;\n    font-weight: 200;\n    cursor: pointer;\n    background-color: ", ";\n    border: 1px solid ", ";\n  }\n  > div > div:last-of-type {\n    background-color: ", ";\n    margin: 0 0.5em;\n    box-shadow: 0 0 20px 2px ", ";\n  }\n  .cb_accordion_item {\n    padding: 1em;\n    // opacity: 0;\n    transition: opacity 300ms ease;\n    overflow: auto;\n  }\n  > div:first-child .cb_accordion_item {\n    max-height: 200px;\n  }\n  > div.open .cb_accordion_item {\n    opacity: 1;\n    transition: opacity 700ms ease;\n  }\n  img.cb_accordion_item {\n    padding: 0;\n    margin: 0;\n    width: 100%;\n  }\n"])), function (_ref4) {
  var theme = _ref4.theme;
  return theme.colors.color;
}, function (_ref5) {
  var theme = _ref5.theme;
  return theme.colors.color;
}, function (_ref6) {
  var theme = _ref6.theme;
  return theme.colors.background;
}, function (_ref7) {
  var theme = _ref7.theme;
  return theme.colors.accordion.border;
}, function (_ref8) {
  var theme = _ref8.theme;
  return theme.colors.accordion.background;
}, function (_ref9) {
  var theme = _ref9.theme;
  return theme.colors.accordion.shadow;
});
var CBToolbarButton = styled__default.button(_templateObject4 || (_templateObject4 = _taggedTemplateLiteralLoose(["\n  padding: 4px 10px;\n  font: 13px 'Montserrat';\n  font-weight: 700;\n  letter-spacing: 2px;\n  text-transform: uppercase;\n  text-decoration: none;\n  text-align: center;\n  opacity: 0.5;\n  color: ", ";\n  background-color: transparent;\n  transition: 0.2s ease-in-out;\n  border: 0;\n  border-bottom: transparent 3px solid;\n  border-radius: 0px;\n  cursor: pointer;\n  &:hover {\n    opacity: 1;\n    background-color: transparent;\n    border-bottom: ", " 3px solid;\n  }\n"])), function (_ref10) {
  var theme = _ref10.theme;
  return theme.colors.color;
}, function (_ref11) {
  var theme = _ref11.theme;
  return theme.colors.color;
});
var CBToolbarAnchor = styled__default.a(_templateObject5 || (_templateObject5 = _taggedTemplateLiteralLoose(["\n  padding: 4px 10px;\n  font: 13px 'Montserrat';\n  font-weight: 700;\n  letter-spacing: 2px;\n  text-transform: uppercase;\n  text-decoration: none;\n  text-align: center;\n  opacity: 0.5;\n  color: ", ";\n  background-color: transparent;\n  transition: 0.2s ease-in-out;\n  border: 0;\n  border-bottom: transparent 3px solid;\n  border-radius: 0px;\n  cursor: pointer;\n  &:hover {\n    opacity: 1;\n    background-color: transparent;\n    border-bottom: ", " 3px solid;\n  }\n"])), function (_ref12) {
  var theme = _ref12.theme;
  return theme.colors.color;
}, function (_ref13) {
  var theme = _ref13.theme;
  return theme.colors.color;
});
var CBGridRow = styled__default.div(_templateObject6 || (_templateObject6 = _taggedTemplateLiteralLoose(["\n  display: grid;\n  width: 100%;\n  color: ", ";\n"])), function (_ref14) {
  var theme = _ref14.theme;
  return theme.colors.color;
});
var CBGridCell = styled__default.div(_templateObject7 || (_templateObject7 = _taggedTemplateLiteralLoose(["\n  width: 100%;\n  margin-bottom: 1rem;\n  > div {\n    border: 1px solid ", ";\n    width: 100%;\n    height: 30px;\n    display: flex;\n    align-items: center;\n    padding: 0 1rem;\n    box-sizing: border-box;\n    &:nth-child(2) {\n      &:hover {\n        border-color: ", ";\n      }\n    }\n    &:nth-child(1) {\n      border-left: 10px solid ", ";\n      font-weight: 500;\n    }\n\n    // justify-content: center;\n  }\n"])), function (_ref15) {
  var theme = _ref15.theme;
  return theme.colors.border;
}, function (_ref16) {
  var theme = _ref16.theme;
  return theme.colors.borderDark;
}, function (_ref17) {
  var theme = _ref17.theme;
  return theme.colors.border;
});
var CBInput = styled__default.input(_templateObject8 || (_templateObject8 = _taggedTemplateLiteralLoose(["\n  border: none;\n  outline: none;\n  height: 100%;\n  width: 100%;\n  font-family: inherit;\n"])));
var CBSelect = styled__default.select(_templateObject9 || (_templateObject9 = _taggedTemplateLiteralLoose(["\n  border: none;\n  outline: none;\n  height: 100%;\n  width: 100%;\n  font-family: inherit;\n"])));
var CBHelpTip = styled__default.div(_templateObject10 || (_templateObject10 = _taggedTemplateLiteralLoose(["\n  margin: auto;\n  text-align: center;\n  border: 2px solid ", ";\n  border-radius: 50%;\n  width: 20px;\n  height: 20px;\n  font-size: 10px;\n  line-height: 20px;\n  cursor: pointer;\n\n  &:before {\n    content: '?';\n    font-family: sans-serif;\n    font-weight: 700;\n    font-size: 15px;\n    color: ", ";\n  }\n\n  &:hover p {\n    display: block;\n\n    transform-origin: 100% 0%;\n    -webkit-animation: ", " 0.3s ease;\n    animation: ", " 0.3s ease;\n  }\n\n  p {\n    display: none;\n    font-family: sans-serif;\n    text-rendering: optimizeLegibility;\n    -webkit-font-smoothing: antialiased;\n    text-align: center;\n    background-color: ", ";\n    padding: 12px 16px;\n    z-index: 999999;\n    width: 178px;\n    height: auto;\n    position: absolute;\n    //   left: 80%;\n    transform: translate(-45%, 5%);\n    border-radius: 3px;\n    /* \tborder: 1px solid #E0E0E0; */\n    box-shadow: 0 0px 20px 0 rgba(0, 0, 0, 0.1);\n    color: ", ";\n    font-size: 12px;\n    line-height: 18px;\n    z-index: 99;\n    a {\n      color: ", ";\n      text-decoration: none;\n      &:hover {\n        text-decoration: underline;\n      }\n    }\n    &:before {\n      position: absolute;\n      content: '';\n      width: 0;\n      height: 0;\n      border: 10px solid transparent;\n      border-bottom-color: ", ";\n      top: -9px;\n      left: 50%;\n      transform: translate(-50%, -50%);\n    }\n    &:after {\n      width: 10px;\n      height: 40px;\n      content: '';\n      position: absolute;\n      top: -40px;\n      left: 0;\n    }\n  }\n"])), function (_ref18) {
  var theme = _ref18.theme;
  return theme.colors.border;
}, function (_ref19) {
  var theme = _ref19.theme;
  return theme.colors.highlight;
}, fadeIn, fadeIn, function (_ref20) {
  var theme = _ref20.theme;
  return theme.colors.background;
}, function (_ref21) {
  var theme = _ref21.theme;
  return theme.colors.color;
}, function (_ref22) {
  var theme = _ref22.theme;
  return theme.colors.highlight;
}, function (_ref23) {
  var theme = _ref23.theme;
  return theme.colors.border;
});
var modalShowStyle = styled.css(_templateObject11 || (_templateObject11 = _taggedTemplateLiteralLoose(["\n  top: 0;\n"])));
var CBModal = styled__default.div(_templateObject12 || (_templateObject12 = _taggedTemplateLiteralLoose(["\n  display: block;\n  position: fixed;\n\n  top: 0;\n  left: 0;\n  width: 100vw !important;\n  height: 100vh !important;\n  z-index: 999;\n  -webkit-backdrop-filter: blur(10px);\n  backdrop-filter: blur(10px);\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  div {\n    overflow: hidden !important;\n    box-sizing: border-box;\n  }\n  > div {\n    background: ", ";\n    border: 2px solid ", ";\n    width: 90%;\n    height: 80%;\n    border-radius: 8px;\n    > div {\n      display: flex;\n      flex-direction: column;\n      box-sizing: border-box;\n      height: 100%;\n      padding: 1rem;\n    }\n  }\n\n  ", "\n"])), function (_ref24) {
  var theme = _ref24.theme;
  return theme.colors.background;
}, function (_ref25) {
  var theme = _ref25.theme;
  return theme.colors.border;
}, function (props) {
  return props.state === '1' && modalShowStyle;
});
var CBAttributeRow = styled__default.div(_templateObject13 || (_templateObject13 = _taggedTemplateLiteralLoose(["\n  cursor: pointer;\n  border-left: 4px solid transparent;\n  height: 40px;\n  padding: 0px 1rem;\n  &:hover {\n    border-color: ", ";\n    background-color: ", ";\n  }\n  > div {\n    display: flex;\n    align-items: center;\n  }\n"])), function (_ref26) {
  var theme = _ref26.theme;
  return theme.colors.highlight;
}, function (_ref27) {
  var theme = _ref27.theme;
  return theme.colors.background;
});
var CBTabContainer = styled__default.div(_templateObject14 || (_templateObject14 = _taggedTemplateLiteralLoose(["\n  display: flex;\n  ul {\n    display: flex;\n    flex-direction: column;\n    border-right: 1px solid ", ";\n    padding: 0 1rem 0rem 0;\n  }\n  > div {\n    padding: 1rem;\n    display: flex;\n    flex-direction: column;\n    height: 100%;\n    > div {\n      overflow: auto !important;\n      > div {\n        &:nth-child(2) {\n          height: 100%;\n        }\n      }\n    }\n  }\n"])), function (_ref28) {
  var theme = _ref28.theme;
  return theme.colors.border;
});
var CBFilterInput = styled__default.input(_templateObject15 || (_templateObject15 = _taggedTemplateLiteralLoose(["\n  font-size: 12px;\n  display: block;\n  width: 100%;\n  height: 36px;\n  padding: 0 20px;\n  background: ", ";\n  color: ", ";\n  border: 1px solid #3d85d8;\n  border-radius: 4px;\n  box-sizing: border-box;\n  &:focus {\n    outline: none;\n    ~ .cb_floating_label {\n      top: -8px;\n      font-size: 13px;\n    }\n  }\n"])), function (_ref29) {
  var theme = _ref29.theme;
  return theme.colors.background;
}, function (_ref30) {
  var theme = _ref30.theme;
  return theme.colors.color;
});
var CBTab = styled__default.div(_templateObject16 || (_templateObject16 = _taggedTemplateLiteralLoose(["\n  width: 100%;\n  padding: 25px;\n  font-family: sans-serif;\n  color: ", ";\n  ul.inline {\n    list-style: none;\n    padding: 0;\n    margin-bottom: 0;\n    -webkit-margin-before: 0;\n    -webkit-margin-after: 0;\n    -webkit-margin-start: 0px;\n    -webkit-margin-end: 0px;\n    -webkit-padding-start: 0px;\n  }\n"])), function (_ref31) {
  var theme = _ref31.theme;
  return theme.colors.color;
});
var CBTabPanelList = styled__default.li(_templateObject17 || (_templateObject17 = _taggedTemplateLiteralLoose(["\n  display: inline-block;\n  margin-left: 0;\n  padding: 10px;\n  border-bottom: 2px solid ", ";\n  transition: all 0.5s;\n  font-family: Lato, sans-serif;\n  font-weight: 300;\n  cursor: pointer;\n  text-transform: capitalize;\n  color: ", ";\n  opacity: ", ";\n  border-right: 4px solid\n    ", ";\n"])), function (_ref32) {
  var theme = _ref32.theme;
  return theme.colors.border;
}, function (_ref33) {
  var theme = _ref33.theme;
  return theme.colors.color;
}, function (props) {
  return props.selected ? '1' : '0.5';
}, function (props) {
  return props.selected ? props.theme.colors.highlight : 'transparent';
});

var Tabs = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Tabs, _Component);

  function Tabs() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.state = {
      selected: _this.props.selected || 0
    };
    return _this;
  }

  var _proto = Tabs.prototype;

  _proto.handleChange = function handleChange(index) {
    this.setState({
      selected: index
    });
  };

  _proto.render = function render() {
    var _this2 = this;

    return /*#__PURE__*/React__default.createElement(React.Fragment, null, /*#__PURE__*/React__default.createElement("ul", null, this.props.children.map(function (elem, index) {
      return /*#__PURE__*/React__default.createElement(CBTabPanelList, {
        key: index,
        selected: index === _this2.state.selected,
        onClick: function onClick() {
          return _this2.handleChange(index);
        }
      }, elem.props.title);
    })), /*#__PURE__*/React__default.createElement(CBTab, null, this.props.children[this.state.selected]));
  };

  return Tabs;
}(React.Component);

function Panel(props) {
  console.log("Panel props.children: ", props.children);
  return /*#__PURE__*/React__default.createElement("div", null, props.children);
}

var _excluded = ["selected", "onChange", "onClose", "show"];
var PropertyBrowser = function PropertyBrowser(_ref) {
  var onChange = _ref.onChange,
      onClose = _ref.onClose,
      show = _ref.show,
      rest = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = React.useState([]);

  var _useState2 = React.useState({}),
      sortedProps = _useState2[0],
      setSortedProps = _useState2[1];

  React.useEffect(function () {
    var res = prepareList(Templates);
    setSortedProps(res);
  }, []);

  var onRowClicked = function onRowClicked(val) {
    if (onChange) {
      onChange(val);
    }
  };

  var onFilterTextChanged = function onFilterTextChanged(val) {
    setSortedProps(prepareList(Templates.filter(function (t) {
      return t.display.indexOf(val) > -1 || t.description.indexOf(val) > -1 || t.propertyName.indexOf(val) > -1;
    })));
  };

  var prepareList = function prepareList(list) {
    var res = {};
    res['#All'] = {};
    list.forEach(function (t) {
      var index = t.display.substring(0, 1);
      res['#All'][index] = res['#All'][index] || [];
      res['#All'][index].push(t);
      t.categories.forEach(function (c) {
        res[c] = res[c] || {};
        res[c][index] = res[c][index] || [];
        res[c][index].push(t);
      });
    });
    res = Object.keys(res).sort().reduce(function (result, key) {
      result[key] = res[key];
      return result;
    }, {});
    return res;
  };

  return /*#__PURE__*/React.createElement(CBModal, {
    state: show ? '1' : '0',
    onClick: function onClick() {
      return onClose();
    }
  }, /*#__PURE__*/React.createElement("div", {
    onClick: function onClick(e) {
      e.stopPropagation();
      e.preventDefault();
    }
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      height: '70px'
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/React.createElement("h1", null, " CSS Attribute Browser")), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("input", {
    type: "button",
    value: "close",
    onClick: function onClick() {
      return onClose();
    }
  }), ' ')), /*#__PURE__*/React.createElement("div", {
    style: {
      height: '60px'
    }
  }, /*#__PURE__*/React.createElement(CBFilterInput, {
    type: "text",
    placeholder: "FILTER",
    onChange: function onChange(e) {
      return onFilterTextChanged(e.target.value);
    }
  })), /*#__PURE__*/React.createElement(CBTabContainer, {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/React.createElement(Tabs, null, Object.keys(sortedProps).sort().map(function (catkey, cati) {
    return /*#__PURE__*/React.createElement(Panel, {
      title: catkey,
      key: cati
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        overflow: 'auto !important'
      }
    }, Object.keys(sortedProps[catkey]).sort().map(function (index, indexi) {
      return /*#__PURE__*/React.createElement("div", {
        key: indexi
      }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("label", null, index)), /*#__PURE__*/React.createElement("div", null, sortedProps[catkey][index].map(function (c, ci) {
        return /*#__PURE__*/React.createElement(CBAttributeRow, {
          style: {
            display: 'flex'
          },
          onClick: function onClick() {
            return onRowClicked(c);
          },
          key: ci
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            width: '20%'
          }
        }, c.display), /*#__PURE__*/React.createElement("div", {
          style: {
            flex: 1
          }
        }, c.description));
      })));
    })));
  }))))));
};

var ControlTemplate = function ControlTemplate(_ref) {
  var field = _ref.field,
      onChange = _ref.onChange;

  var _useState = React.useState({}),
      fieldData = _useState[0],
      setFieldData = _useState[1];

  var _useState2 = React.useState([]),
      subFiledValues = _useState2[0];

  React.useEffect(function () {
    setFieldData(field || {});
  }, [field]);

  var onPropertyValueChange = function onPropertyValueChange(value) {
    fieldData.value = value;
    setFieldData(_extends({}, fieldData));

    if (onChange) {
      if (typeof fieldData.value === 'string' && fieldData.value.indexOf("{") === 0) {
        var v = JSON.parse(fieldData.value);

        if (typeof v.value === 'string' && v.value.indexOf("{")) ; else {
          onChange((fieldData.valuetemplate || '{0}').replace("{" + 0 + "}", v.value));
        }
      } else {
        onChange((fieldData.valuetemplate || '{0}').replace("{" + 0 + "}", value));
      }
    }
  };

  var onSubControlValueChanged = function onSubControlValueChanged(control, value, index, f) {
    var res = f.valuetemplate || "{0}";

    for (var i = 0; i <= index; i++) {
      subFiledValues[i] = subFiledValues[i] || '';
    }

    subFiledValues[index] = value;

    for (var j = 0; j < subFiledValues.length; j++) {
      res = res.replace("{" + j + "}", subFiledValues[j]);
    }

    if (onChange) {
      onChange(res);
    }
  };

  var getSubControls = function getSubControls() {
    var res = [];

    if (fieldData.value && typeof fieldData.value === 'string' && fieldData.value.indexOf("{") === 0) {
      var obj = JSON.parse(fieldData.value);
      obj.value.controls.forEach(function (c, ci) {
        res.push( /*#__PURE__*/React__default.createElement(ControlTemplate, {
          field: c,
          onChange: function onChange(val) {
            onSubControlValueChanged(c, val, ci, obj);
          }
        }));
      });
    }

    return res;
  };

  var getControl = function getControl() {
    var res = [];
    var output = [];

    switch (fieldData.type) {
      case 'select':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          className: "cb-floating-label-content",
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBSelect, {
          className: "cb-floating-select",
          value: fieldData.value,
          onChange: function onChange(e) {
            return onPropertyValueChange(e.target.value);
          },
          style: {
            width: '100%'
          }
        }, fieldData.options.map(function (o, oi) {
          return /*#__PURE__*/React__default.createElement("option", {
            value: typeof o.value === 'object' ? JSON.stringify(o) : o.value,
            key: oi
          }, "" + o.name);
        }))));
        break;

      case 'radio':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          className: "radio-toolbar",
          style: {
            flex: 1
          }
        }, fieldData.options.map(function (o, oi) {
          return /*#__PURE__*/React__default.createElement(React.Fragment, {
            key: oi
          }, /*#__PURE__*/React__default.createElement(CBInput, {
            type: "radio",
            id: "radio-" + o.name,
            name: "radio-" + o.name,
            value: o.value,
            checked: o.value === fieldData.value
          }), /*#__PURE__*/React__default.createElement("label", {
            "for": "radioBanana"
          }, o.name));
        })));
        break;

      case 'color':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBInput, {
          type: "color",
          id: "favcolor",
          name: "favcolor",
          value: fieldData.value,
          style: {
            padding: '0px',
            border: 'none',
            width: '100%',
            height: '20px'
          },
          onChange: function onChange(e) {
            return onPropertyValueChange(e.target.value);
          }
        })));
        break;

      case 'number':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBInput, {
          type: "number",
          id: "favcolor",
          name: "favcolor",
          value: fieldData.value,
          onChange: function onChange(e) {
            return onPropertyValueChange(e.target.value);
          }
        })));
        break;

      case 'range':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBInput, {
          type: "range",
          min: fieldData.min || '1',
          max: fieldData.max || '100',
          value: fieldData.value,
          style: {
            width: '100%'
          },
          onChange: function onChange(e) {
            return onPropertyValueChange(e.target.value * (fieldData.multiplier || 1));
          }
        })));
        break;

      case 'text':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBInput, {
          type: "text",
          id: "favcolor",
          name: "favcolor",
          placeholder: fieldData.label,
          value: fieldData.value,
          onChange: function onChange(e) {
            return onPropertyValueChange(e.target.value);
          }
        })));
    }

    res = res.concat([/*#__PURE__*/React__default.createElement(CBGridCell, null, /*#__PURE__*/React__default.createElement("div", {
      style: {
        flex: 1,
        display: 'flex'
      }
    }, /*#__PURE__*/React__default.createElement("div", {
      style: {
        flex: 1
      }
    }, fieldData.label), /*#__PURE__*/React__default.createElement(CBHelpTip, null, /*#__PURE__*/React__default.createElement("p", null, fieldData.description, /*#__PURE__*/React__default.createElement("br", null), /*#__PURE__*/React__default.createElement("span", {
      style: {
        fontWeight: '500'
      }
    }, "Default: "), fieldData["default"], /*#__PURE__*/React__default.createElement("br", null), /*#__PURE__*/React__default.createElement("a", {
      href: fieldData.link || 'https://www.w3schools.com/cssref/',
      target: "_blank"
    }, "W3School Definition")))), /*#__PURE__*/React__default.createElement("div", null, output))]);
    res = res.concat(getSubControls());
    return res;
  };

  var allcontrols = getControl();
  return /*#__PURE__*/React__default.createElement(CBGridRow, {
    style: {
      gridTemplateColumns: "repeat(" + allcontrols.length + ", 1fr)"
    }
  }, getControl());
};

var Accordion = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Accordion, _React$Component);

  function Accordion(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.state = {
      index: typeof props.selectedIndex !== 'undefined' ? props.selectedIndex : -1
    };
    _this.nodes = [];
    return _this;
  }

  var _proto = Accordion.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(props) {
    if (typeof props.selectedIndex !== 'undefined' && this.state.index !== props.selectedIndex) {
      this.toggle(props.selectedIndex);
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    clearTimeout(this.timeout);
  };

  _proto.toggle = function toggle(index, click) {
    var _this2 = this;

    clearTimeout(this.timeout);

    if (click) {
      if (this.props.onChange) this.props.onChange(index, this.state.index !== index, this.state.index !== index ? index : -1);
      if (!this.props.changeOnClick) return;
    }

    if (this.state.index > -1) {
      var content = this.nodes[this.state.index].ref.children[1];
      content.style.height = content.children[0].offsetHeight + "px";
    }

    if (this.state.index === index || index === -1) {
      setTimeout(function () {
        _this2.setState({
          index: -1
        });
      }, 50);
    } else {
      setTimeout(function () {
        _this2.setState({
          index: index
        });

        _this2.timeout = setTimeout(function () {
          _this2.nodes[index].ref.children[1].style.height = 'auto';
        }, _this2.props.transitionDuration);
      }, 50);
    }
  };

  _proto.getHeight = function getHeight(index) {
    if (index === this.state.index) {
      return this.nodes.length > index ? this.nodes[index].ref.children[1].children[0].offsetHeight : 'auto';
    }

    return 0;
  };

  _proto.render = function render() {
    var _this3 = this;

    var style = {
      overflow: 'hidden',
      transition: "height " + this.props.transitionDuration + "ms " + this.props.transitionTimingFunction
    };
    var nodes = React__default.Children.map(this.props.children, function (child, index) {
      return /*#__PURE__*/React__default.createElement("div", {
        key: index,
        ref: function ref(div) {
          _this3.nodes[index] = {
            ref: div
          };
        },
        className: _this3.state.index === index ? _this3.props.openClassName : ''
      }, /*#__PURE__*/React__default.createElement("div", {
        style: {
          display: 'flex',
          height: '100%',
          width: '100%',
          boxSizing: "border-box"
        }
      }, /*#__PURE__*/React__default.createElement("div", {
        style: {
          display: 'flex',
          justifyContent: 'center',
          alignItems: 'center',
          width: '50px',
          height: '100%'
        }
      }, /*#__PURE__*/React__default.createElement("div", null)), /*#__PURE__*/React__default.createElement("div", {
        onClick: function onClick() {
          return _this3.toggle(index, true);
        },
        style: {
          flex: 1
        }
      }, child.props['data-header']), /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(CBToolbarAnchor, {
        href: child.props['help-link'],
        target: "_blank"
      }, "Help"), /*#__PURE__*/React__default.createElement(CBToolbarButton, {
        type: "button",
        onClick: function onClick() {
          return child.props['on-change-clicked']();
        }
      }, "Change"), /*#__PURE__*/React__default.createElement(CBToolbarButton, {
        type: "button",
        onClick: function onClick() {
          return child.props['on-remove-clicked']();
        }
      }, "Remove"))), /*#__PURE__*/React__default.createElement("div", {
        style: _extends({}, style, {
          height: _this3.getHeight(index)
        })
      }, child));
    });
    return /*#__PURE__*/React__default.createElement(CBAccordion, null, nodes);
  };

  return Accordion;
}(React__default.Component);

Accordion.defaultProps = {
  transitionDuration: 500,
  transitionTimingFunction: 'ease',
  openClassName: 'open',
  changeOnClick: true
};

var dark = {
  meta: {
    name: 'dark',
    displayName: 'Dark'
  },
  colors: {
    background: '#121212',
    color: '#FFF',
    border: '#454545',
    borderDark: '#202125',
    highlight: '#7bc5ee',
    button: {
      borderColor: '#FFF'
    },
    accordion: {
      background: '#121212',
      shadow: '#FFF',
      border: '#EFEFEF'
    }
  }
};

var chalk = {
  meta: {
    name: 'chalk',
    displayName: 'Chalk'
  },
  colors: {
    background: '#FFF',
    color: '#454545',
    border: '#cdcdcd',
    borderDark: '#454545',
    highlight: '#067df7',
    button: {
      borderColor: '#454545'
    },
    accordion: {
      background: '#f9f9f9',
      shadow: '#cdcdcd',
      border: '#EFEFEF'
    }
  }
};



var Themes = {
  __proto__: null,
  dark: dark,
  chalk: chalk
};

var _excluded$1 = ["tags", "onChange", "inline", "baseTheme", "themeOverride", "config"];
var CSSBuilder = function CSSBuilder(_ref) {
  var onChange = _ref.onChange,
      inline = _ref.inline,
      _ref$baseTheme = _ref.baseTheme,
      baseTheme = _ref$baseTheme === void 0 ? 'chalk' : _ref$baseTheme,
      _ref$themeOverride = _ref.themeOverride,
      themeOverride = _ref$themeOverride === void 0 ? {} : _ref$themeOverride,
      config = _ref.config,
      rest = _objectWithoutPropertiesLoose(_ref, _excluded$1);

  var _useState = React.useState([]),
      allProps = _useState[0],
      setAllProps = _useState[1];

  var _useState2 = React.useState(false),
      showPropertyBorwser = _useState2[0],
      setShowPropertyBorwser = _useState2[1];

  var _useState3 = React.useState(-1),
      selectedProperty = _useState3[0],
      setSelectedProperty = _useState3[1];

  var _useState4 = React.useState(-1),
      selectedIndex = _useState4[0],
      setSelectedIndex = _useState4[1];

  var _React$useState = React.useState({}),
      finalTheme = _React$useState[0],
      setFinalTheme = _React$useState[1];

  var _React$useState2 = React.useState(true),
      loading = _React$useState2[0],
      setLoading = _React$useState2[1];

  React.useEffect(function () {
    var defaultTheme = Themes[baseTheme];
    var oTheme = themeOverride;
    defaultTheme = Object.assign(defaultTheme, oTheme);
    setFinalTheme(defaultTheme);
    setLoading(false);
  }, [config]);

  var onRowAdd = function onRowAdd() {
    setSelectedProperty(allProps.length);
    setShowPropertyBorwser(true);
  };

  var onPropertyChange = function onPropertyChange(value) {
    setShowPropertyBorwser(false);
    allProps[selectedProperty] = Templates.filter(function (f) {
      return f.name === value.name && f.propertyName === value.propertyName;
    })[0];
    allProps[selectedProperty].controls.forEach(function (c) {
      c.value = c["default"] ? c["default"] : '';
    });
    setAllProps(JSON.parse(JSON.stringify(allProps)));
    fireOnChange(allProps);
    setSelectedIndex(selectedProperty);
  };

  var onPropertyValueChange = function onPropertyValueChange(value, controlindex, rowindex) {
    allProps[rowindex].controls[controlindex].value = "" + (allProps[rowindex].controls[controlindex].prefix || '') + value + (allProps[rowindex].controls[controlindex].suffix || '');
    setAllProps(allProps);
    fireOnChange(allProps);
  };

  var camelCase = function camelCase(input) {
    return input.toLowerCase().replace(/-(.)/g, function (match, group1) {
      return group1.toUpperCase();
    });
  };

  var fireOnChange = function fireOnChange(styles) {
    var resStyle = inline ? {} : '';
    styles.forEach(function (row) {
      if (Object.keys(row).length) {
        var styleName = inline ? camelCase(row.propertyName) : row.propertyName;
        var styleValue = row.valuetemplate || '${0}';
        row.controls.forEach(function (c, ci) {
          styleValue = styleValue.replace("{" + ci + "}", c.value || '');
        });

        if (inline) {
          resStyle[styleName] = styleValue;
        } else {
          resStyle = "" + resStyle + styleName + ":" + styleValue + ";}";
        }
      }
    });

    if (onChange) {
      onChange(resStyle);
    }
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, loading ? null : /*#__PURE__*/React.createElement(styled.ThemeProvider, {
    theme: finalTheme
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: '100%',
      display: 'flex',
      flexDirection: 'column'
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: '60px',
      padding: '1rem'
    }
  }, /*#__PURE__*/React.createElement(CBSimpleButton, {
    type: "button",
    value: "+ CSS attribute",
    onClick: function onClick() {
      return onRowAdd();
    },
    style: {
      height: '40px'
    }
  })), /*#__PURE__*/React.createElement("div", {
    style: {
      overflow: 'auto',
      flex: 1
    }
  }, /*#__PURE__*/React.createElement(Accordion, {
    selectedIndex: selectedIndex,
    onChange: function onChange(index, expanded, si) {
      return setSelectedIndex(si);
    }
  }, allProps.map(function (prop, propi) {
    return /*#__PURE__*/React.createElement("div", {
      "data-header": "" + (prop.display || 'No attribute selected'),
      "help-link": prop.link,
      "on-remove-clicked": function onRemoveClicked() {
        allProps.splice(propi, 1);
        setAllProps(JSON.parse(JSON.stringify(allProps)));
        fireOnChange(allProps);
      },
      "on-change-clicked": function onChangeClicked() {
        setSelectedProperty(propi);
        setShowPropertyBorwser(true);
      }
    }, prop.controls.map(function (c, ci) {
      return /*#__PURE__*/React.createElement("div", {
        style: {
          flex: 1
        },
        key: ci
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          display: 'flex'
        }
      }, /*#__PURE__*/React.createElement(ControlTemplate, {
        field: c,
        onChange: function onChange(val) {
          onPropertyValueChange(val, ci, propi);
        }
      })));
    }));
  }))), showPropertyBorwser ? /*#__PURE__*/React.createElement(PropertyBrowser, {
    show: showPropertyBorwser,
    onChange: function onChange(val) {
      return onPropertyChange(val);
    },
    onClose: function onClose() {
      return setShowPropertyBorwser(false);
    }
  }) : null)));
};

exports.CSSBuilder = CSSBuilder;
//# sourceMappingURL=index.js.map
