import React__default, { Component, Fragment, useState, useEffect, createElement } from 'react';
import styled, { keyframes, css, ThemeProvider } from 'styled-components';

var b = [
	{
		display: "Border",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border",
		valuetemplate: "{0}px {1} {2}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "number",
				label: "Width",
				min: "0",
				max: "100",
				"default": "1"
			},
			{
				type: "select",
				label: "Pattern",
				"default": "none",
				options: [
					{
						name: "Solid",
						value: "solid"
					},
					{
						name: "Dotted",
						value: "dotted"
					},
					{
						name: "Dashed",
						value: "dashed"
					},
					{
						name: "Double",
						value: "double"
					},
					{
						name: "Groove",
						value: "groove"
					},
					{
						name: "Ridge",
						value: "ridge"
					},
					{
						name: "Inset",
						value: "inset"
					},
					{
						name: "Outset",
						value: "outset"
					},
					{
						name: "Initial",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Hidden",
						value: "hidden"
					}
				]
			},
			{
				type: "color",
				label: "Color",
				"default": "#000"
			}
		]
	},
	{
		display: "Border Radius (Custom)",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-radius",
		valuetemplate: "{0}{1}",
		categories: [
			"border"
		],
		tags: " presentation",
		controls: [
			{
				type: "range",
				label: "Amount",
				min: "0",
				max: "100",
				"default": "0px"
			},
			{
				type: "select",
				label: "Unit",
				"default": "px",
				options: [
					{
						name: "Pixels",
						value: "px"
					},
					{
						name: "Percentage",
						value: "%"
					}
				]
			}
		]
	},
	{
		display: "Color: Border",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Color: Border : Left",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-left-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Color: Border: Right",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-right-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Color: Border: Top",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-top-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Color: Border : Bottom",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-bottom-color",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color,  presentation",
		controls: [
			{
				type: "color",
				label: "Color",
				"default": "inherit"
			}
		]
	},
	{
		display: "Border : Bottom",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-bottom",
		valuetemplate: "{0}",
		categories: [
			"color",
			"border"
		],
		tags: "color, presentation",
		controls: [
			{
				type: "range",
				label: "Width",
				min: "0",
				max: "100",
				"default": "1",
				suffix: "px"
			},
			{
				type: "select",
				label: "Pattern",
				"default": "none",
				options: [
					{
						name: "Solid",
						value: "solid"
					},
					{
						name: "Dotted",
						value: "dotted"
					},
					{
						name: "Dashed",
						value: "dashed"
					},
					{
						name: "Double",
						value: "double"
					},
					{
						name: "Groove",
						value: "groove"
					},
					{
						name: "Ridge",
						value: "ridge"
					},
					{
						name: "Inset",
						value: "inset"
					},
					{
						name: "Outset",
						value: "outset"
					},
					{
						name: "Initial",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Hidden",
						value: "hidden"
					}
				]
			},
			{
				type: "color",
				label: "Color",
				"default": "#000"
			}
		]
	},
	{
		display: "Border Radius (Custom)",
		description: "This property specifies the default alignment for items inside the flexible container",
		propertyName: "border-radius",
		valuetemplate: "{0}{1}",
		categories: [
			"border"
		],
		tags: "presentation",
		controls: [
			{
				type: "range",
				label: "Amount",
				min: "0",
				max: "100",
				"default": "1"
			},
			{
				type: "select",
				label: "Unit",
				"default": "px",
				options: [
					{
						name: "Pixels",
						value: "px"
					},
					{
						name: "Percentage",
						value: "%"
					}
				]
			}
		]
	}
];

var c = [
	{
		display: "Table Caption",
		description: "Specifies the placement of a table caption",
		link: "https://www.w3schools.com/cssref/pr_tab_caption-side.asp",
		propertyName: "caption-side",
		valuetemplate: "{0}",
		categories: [
			"caption",
			"table"
		],
		tags: "all, table",
		controls: [
			{
				type: "select",
				"default": "top",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Top",
						value: "top"
					},
					{
						name: "Bottom",
						value: "bottom"
					}
				]
			}
		]
	},
	{
		display: "Caret Color",
		description: "Specifies the color of the cursor (caret) in inputs, textareas, or any element that is editable",
		link: "https://www.w3schools.com/cssref/css3_pr_caret-color.asp",
		propertyName: "caret-color",
		valuetemplate: "{0}",
		categories: [
			"color"
		],
		tags: "color",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Color",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "color",
									label: "Custom Color"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Charset",
		description: "Specifies the character encoding to use",
		link: "https://www.w3schools.com/cssref/pr_charset_rule.asp",
		propertyName: "@charset",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "meta",
		controls: [
			{
				type: "text",
				"default": ""
			}
		]
	},
	{
		display: "Clear",
		description: "Specifies what should happen with the element that is next to a floating element",
		link: "https://www.w3schools.com/cssref/pr_class_clear.asp",
		propertyName: "clear",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "meta",
		controls: [
			{
				type: "select",
				label: "Clear Property",
				"default": "none",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "None",
						value: "None"
					},
					{
						name: "Left",
						value: "left"
					},
					{
						name: "Right",
						value: "right"
					},
					{
						name: "Bottom",
						value: "bottom"
					}
				]
			}
		]
	},
	{
		display: "Clip",
		description: "Clips an absolutely positioned element",
		link: "https://www.w3schools.com/cssref/pr_pos_clip.asp",
		propertyName: "clip",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "meta",
		controls: [
			{
				type: "select",
				label: "Clip",
				"default": "auto",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Shape",
						valuetemplate: "shape({0} {1} {2} {3})",
						value: {
							controls: [
								{
									type: "number",
									label: "Top"
								},
								{
									type: "number",
									label: "Right"
								},
								{
									type: "number",
									label: "Bottom"
								},
								{
									type: "number",
									label: "Left"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Color",
		description: "Set the text-color for different elements",
		link: "https://www.w3schools.com/cssref/pr_text_color.asp",
		propertyName: "color",
		valuetemplate: "{0}",
		categories: [
			"color"
		],
		tags: "color",
		controls: [
			{
				type: "select",
				label: "Value",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "color",
									label: "Custom Color"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Column Count",
		description: "Specifies the number of columns an element should be divided into",
		link: "https://www.w3schools.com/cssref/css3_pr_column-count.asp",
		propertyName: "column-count",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				defaukt: "auto",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "number",
									label: "Count"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Column Fills",
		description: "Specifies how to fill columns, balanced or not",
		link: "https://www.w3schools.com/cssref/css3_pr_column-fill.asp",
		propertyName: "column-fill",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "balance",
				options: [
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Balance",
						value: "balance"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Gap",
		description: "Specifies the gap between the columns",
		link: "https://www.w3schools.com/cssref/css3_pr_column-gap.asp",
		propertyName: "column-gap",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "normal",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Gap(in px)"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Rule",
		description: "Container column rule",
		link: "https://www.w3schools.com/cssref/css3_pr_column-rule.asp",
		propertyName: "column-rule",
		valuetemplate: "{0} {1} {2}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Width",
				"default": "medium",
				link: "https://www.w3schools.com/cssref/css3_pr_column-rule-width.asp",
				description: "Specifies the width of the rule between columns",
				options: [
					{
						name: "Medium",
						value: "medium"
					},
					{
						name: "Thin",
						value: "thin"
					},
					{
						name: "Thick",
						value: "thick"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Custom Width"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			},
			{
				type: "select",
				label: "Styles",
				description: "Specifies the style of the rule between columns",
				link: "https://www.w3schools.com/cssref/css3_pr_column-rule-style.asp",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "Hidden",
						value: "hidden"
					},
					{
						name: "Dotted",
						value: "dotted"
					},
					{
						name: "Dashed",
						value: "dashed"
					},
					{
						name: "Solid",
						value: "solid"
					},
					{
						name: "Double",
						value: "double"
					},
					{
						name: "Groove",
						value: "groove"
					},
					{
						name: "Ridge",
						value: "ridge"
					},
					{
						name: "Inset",
						value: "inset"
					},
					{
						name: "Outset",
						value: "outset"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			},
			{
				type: "select",
				label: "Color",
				"default": "inherit",
				description: "Specifies the color of the rule between columns",
				link: "https://www.w3schools.com/cssref/css3_pr_column-rule-color.asp",
				options: [
					{
						name: "Custom",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "color",
									label: "Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			},
			{
				name: "Default value",
				value: "initial"
			},
			{
				name: "Inherit from parent",
				value: "inherit"
			}
		]
	},
	{
		display: "Column Rule: Color",
		link: "https://www.w3schools.com/cssref/css3_pr_column-rule-width.asp",
		description: "Specifies the width of the rule between columns",
		propertyName: "column-rule-color",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Color",
				"default": "inherit",
				description: "Specifies the color of the rule between columns",
				link: "https://www.w3schools.com/cssref/css3_pr_column-rule-color.asp",
				options: [
					{
						name: "Custom",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "color",
									label: "Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Rule: Style",
		description: "Specifies the style of the rule between columns",
		link: "https://www.w3schools.com/cssref/css3_pr_column-rule-style.asp",
		propertyName: "column-rule-style",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Styles",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "Hidden",
						value: "hidden"
					},
					{
						name: "Dotted",
						value: "dotted"
					},
					{
						name: "Dashed",
						value: "dashed"
					},
					{
						name: "Solid",
						value: "solid"
					},
					{
						name: "Double",
						value: "double"
					},
					{
						name: "Groove",
						value: "groove"
					},
					{
						name: "Ridge",
						value: "ridge"
					},
					{
						name: "Inset",
						value: "inset"
					},
					{
						name: "Outset",
						value: "outset"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Rule: Width",
		link: "https://www.w3schools.com/cssref/css3_pr_column-rule-width.asp",
		description: "Specifies the width of the rule between columns",
		propertyName: "column-rule-width",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Width",
				"default": "medium",
				options: [
					{
						name: "Medium",
						value: "medium"
					},
					{
						name: "Thin",
						value: "thin"
					},
					{
						name: "Thick",
						value: "thick"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Custom Width"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Span",
		link: "https://www.w3schools.com/cssref/css3_pr_column-span.asp",
		description: "Specifies how many columns an element should span across",
		propertyName: "column-span",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Width",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "All",
						value: "all"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Column Width",
		link: "https://www.w3schools.com/cssref/css3_pr_column-width.asp",
		description: "Specifies the column width",
		propertyName: "column-width",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Width",
				"default": "none",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Length"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Columns",
		link: "https://www.w3schools.com/cssref/css3_pr_columns.asp",
		description: "Specifies the column definition",
		propertyName: "columns",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Column Width",
				"default": "auto",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px {1}",
						value: {
							controls: [
								{
									type: "number",
									label: "Custom Width"
								},
								{
									type: "number",
									label: "Column Count"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Content",
		link: "https://www.w3schools.com/cssref/pr_gen_content.asp",
		description: "Used with the :before and :after pseudo-elements, to insert generated content",
		propertyName: "content",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "normal",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Counter",
						valuetemplate: "counter({0})",
						value: {
							controls: [
								{
									type: "number",
									label: "Counter Value"
								}
							]
						}
					},
					{
						name: "Attribute",
						valuetemplate: "attr({0})",
						value: {
							controls: [
								{
									type: "text",
									label: "Attribute Value"
								}
							]
						}
					},
					{
						name: "String",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "text",
									label: "String Value"
								}
							]
						}
					},
					{
						name: "Open Quote",
						value: "open-quote"
					},
					{
						name: "Close Quote",
						value: "close-quote"
					},
					{
						name: "No Open Quote",
						value: "no-open-quote"
					},
					{
						name: "No Close Quote",
						value: "no-close-quote"
					},
					{
						name: "URL",
						valuetemplate: "url({0})",
						value: {
							controls: [
								{
									type: "text",
									label: "URL Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Counter Increment",
		link: "https://www.w3schools.com/cssref/pr_gen_counter-increment.asp",
		description: "Increases or decreases the value of one or more CSS counters",
		propertyName: "counter-increment",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "Identifier",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "text",
									label: "ID Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Counter Reset",
		link: "https://www.w3schools.com/cssref/pr_gen_counter-reset.asp",
		description: "Creates or resets one or more CSS counters",
		propertyName: "counter-reset",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				label: "Value",
				"default": "none",
				options: [
					{
						name: "None",
						value: "none"
					},
					{
						name: "Identifier",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "text",
									label: "ID Value"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Cursor",
		link: "https://www.w3schools.com/cssref/playit.asp?filename=playcss_cursor&preval=alias",
		description: "Specifies the mouse cursor to be displayed when pointing over an element",
		propertyName: "cursor",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "meta",
		controls: [
			{
				type: "select",
				label: "Cursor Type",
				"default": "auto",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "Alias",
						value: "alias"
					},
					{
						name: "Cell",
						value: "cell"
					},
					{
						name: "Context Menu",
						value: "context-menu"
					},
					{
						name: "Column Resize",
						value: "col-resize"
					},
					{
						name: "Copy",
						value: "copy"
					},
					{
						name: "Crosshair",
						value: "crosshair"
					},
					{
						name: "Default",
						value: "default"
					},
					{
						name: "Edge Resize",
						value: "e-resize"
					},
					{
						name: "Bidirectional Edge Resize",
						value: "ew-resize"
					},
					{
						name: "Grab-able",
						value: "grab"
					},
					{
						name: "Grabbed",
						value: "grabbing"
					},
					{
						name: "Help",
						value: "help"
					},
					{
						name: "Move Edge",
						value: "move"
					},
					{
						name: "Resize towards North",
						value: "n-resize"
					},
					{
						name: "Resize towards North East",
						value: "ne-resize"
					},
					{
						name: "Resize towards North South East West",
						value: "nesw-resize"
					},
					{
						name: "Resize towards North South",
						value: "ns-resize"
					},
					{
						name: "Resize towards North West",
						value: "nw-resize"
					},
					{
						name: "Resize towards North West South East",
						value: "nwse-resize"
					},
					{
						name: "Cannot drop dragged item",
						value: "no-drop"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Action not allowed",
						value: "not-allowed"
					},
					{
						name: "Pointer",
						value: "pointer"
					},
					{
						name: "Loading / Progress",
						value: "progress"
					},
					{
						name: "Row Resize",
						value: "row-resize"
					},
					{
						name: "Resize towards South",
						value: "s-resize"
					},
					{
						name: "Resize towards South East",
						value: "se-resize"
					},
					{
						name: "Resize towards South West",
						value: "sw-resize"
					},
					{
						name: "Text selection",
						value: "text"
					},
					{
						name: "URL (Custom Cursor)",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "text",
									label: "Coma Separated"
								}
							]
						}
					},
					{
						name: "Vertical text selection",
						value: "vertical-text"
					},
					{
						name: "Resize towards West",
						value: "w-resize"
					},
					{
						name: "Wait",
						value: "wait"
					},
					{
						name: "Zoom IN",
						value: "zoom-in"
					},
					{
						name: "Zoom Out",
						value: "zoom-out"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var d = [
	{
		display: "Direction",
		description: "Specifies the text direction/writing direction",
		link: "https://www.w3schools.com/cssref/pr_text_direction.asp",
		propertyName: "direction",
		valuetemplate: "{0}",
		categories: [
			"container",
			"text"
		],
		tags: "container,text",
		controls: [
			{
				type: "select",
				"default": "ltr",
				options: [
					{
						value: "ltr",
						name: "Left to right"
					},
					{
						value: "rtl",
						name: "Right to left"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Display",
		link: "https://www.w3schools.com/cssref/pr_class_display.asp",
		description: "Specifies how an element should be displayed",
		propertyName: "display",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "meta",
		controls: [
			{
				type: "select",
				label: "Cursor Type",
				"default": "auto",
				options: [
					{
						name: "Inline Display",
						value: "inline"
					},
					{
						name: "Block (New line)",
						value: "block"
					},
					{
						name: "Content Only",
						value: "contents"
					},
					{
						name: "Flexible container",
						value: "flex"
					},
					{
						name: "Inline Block",
						value: "inline-block"
					},
					{
						name: "Inline flex",
						value: "inline flex"
					},
					{
						name: "Inline grid",
						value: "inline-grid"
					},
					{
						name: "Inline table",
						value: "inline-table"
					},
					{
						name: "List item",
						value: "list-item"
					},
					{
						name: "Contextual block or inline",
						value: "run-in"
					},
					{
						name: "Table",
						value: "table"
					},
					{
						name: "Like Caption element",
						value: "table-caption"
					},
					{
						name: "Table column group",
						value: "table-column-group"
					},
					{
						name: "Table header group",
						value: "table-header-group"
					},
					{
						name: "Table footer group",
						value: "table-footer-group"
					},
					{
						name: "Table row group",
						value: "table-row-group"
					},
					{
						name: "Table cell",
						value: "table-cell"
					},
					{
						name: "Table column",
						value: "table-column"
					},
					{
						name: "Table row",
						value: "table-row"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var j = [
	{
		display: "Justify Content Horizontally",
		description: "Specifies the alignment between the items inside a flexible container when the items do not use all available space",
		link: "https://www.w3schools.com/cssref/css3_pr_justify-content.asp",
		propertyName: "justify-content",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "flex, alignment",
		controls: [
			{
				type: "select",
				"default": "flex-start",
				label: "Value",
				options: [
					{
						name: "Start",
						value: "flex-start"
					},
					{
						name: "End",
						value: "flex-end"
					},
					{
						name: "Center",
						value: "center"
					},
					{
						name: "Space Between",
						value: "space-between"
					},
					{
						name: "Space Around",
						value: "space-around"
					},
					{
						name: "Default Value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var u = [
	{
		display: "Unicode Bidi",
		description: "Used together with the direction property to set or return whether the text should be overridden to support multiple languages in the same document.",
		link: "https://www.w3schools.com/cssref/pr_text_unicode-bidi.asp",
		propertyName: "unicode-bidi",
		valuetemplate: "{0}",
		categories: [
			"Misc"
		],
		tags: "direction",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Embed",
						value: "embed"
					},
					{
						name: "Override",
						value: "bidi-override"
					},
					{
						name: "isolate",
						value: "isolate"
					},
					{
						name: "Isolate Ooverride",
						value: "isolate-override"
					},
					{
						name: "Plaintext",
						value: "plaintext"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "User Select",
		description: "Specifies whether the text of an element can be selected.",
		link: "https://www.w3schools.com/cssref/css3_pr_user-select.asp",
		propertyName: "user-select",
		valuetemplate: "{0}",
		categories: [
			"Misc"
		],
		tags: "selection",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Value",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "None",
						value: "none"
					},
					{
						name: "Text",
						value: "text"
					},
					{
						name: "All",
						value: "all"
					}
				]
			}
		]
	}
];

var v = [
	{
		display: "Vertical Align",
		description: "Sets the vertical alignment of an element",
		link: "https://www.w3schools.com/cssref/pr_pos_vertical-align.asp",
		propertyName: "vertical-align",
		valuetemplate: "{0}",
		categories: [
			"alignment",
			"layout",
			"position"
		],
		tags: "alignment, layout, position",
		controls: [
			{
				type: "select",
				"default": "baseline",
				label: "Value",
				options: [
					{
						name: "Align to baseline of container",
						value: "baseline"
					},
					{
						name: "Custom",
						valuetemplate: "{0}{1}",
						value: {
							controls: [
								{
									type: "number",
									label: "Amount",
									"default": "0"
								},
								{
									type: "select",
									label: "Unit",
									"default": "px",
									options: [
										{
											name: "Pixels",
											value: "px"
										},
										{
											name: "Percentage",
											value: "%"
										}
									]
								}
							]
						}
					},
					{
						name: "Align to subscript baseline of container",
						value: "sub"
					},
					{
						name: "Align to superscript baseline of container",
						value: "super"
					},
					{
						name: "Align to top of container",
						value: "top"
					},
					{
						name: "Align to top of the container element's font",
						value: "text-top"
					},
					{
						name: "Align to middle of container",
						value: "middle"
					},
					{
						name: "Align to bottom of container",
						value: "bottom"
					},
					{
						name: "Align to bottom of the container element's font",
						value: "text-bottom"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Visibility",
		description: "Specifies whether or not an element is visible",
		link: "https://www.w3schools.com/cssref/pr_class_visibility.asp",
		propertyName: "visibility",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				"default": "visible",
				label: "Value",
				options: [
					{
						name: "Make element visible",
						value: "visible"
					},
					{
						name: "Make element hidden",
						value: "hidden"
					},
					{
						name: "Collapse table rows and columns",
						value: "collapse"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var w = [
	{
		display: "White Space",
		description: "Specifies how white-space inside an element is handled",
		link: "https://www.w3schools.com/cssref/pr_text_white-space.asp",
		propertyName: "white-space",
		valuetemplate: "{0}",
		categories: [
			"container",
			"text"
		],
		tags: "container,text",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "No Wrap",
						value: "nowrap"
					},
					{
						name: "Whitespace preserved and wraps on line breaks",
						value: "pre"
					},
					{
						name: "Whitespace preserved and collapse on single whitespace",
						value: "pre-line"
					},
					{
						name: "Whitespace preserved and wraps when necessary",
						value: "pre-wrap"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Width",
		description: "Specifies the width of an element",
		link: "https://www.w3schools.com/cssref/pr_dim_width.asp",
		propertyName: "width",
		valuetemplate: "{0}",
		categories: [
			"container"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Value",
				options: [
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Length"
								}
							]
						}
					},
					{
						name: "Percentage",
						value: "%"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Word Break",
		description: "Specifies how words should break when reaching the end of a line",
		link: "https://www.w3schools.com/cssref/css3_pr_word-break.asp",
		propertyName: "word-break",
		valuetemplate: "{0}",
		categories: [
			"container",
			"word"
		],
		tags: "container,word",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Break All",
						value: "break-all"
					},
					{
						name: "Keep All",
						value: "keep-all"
					},
					{
						name: "Break Word",
						value: "break-word"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Word Spacing",
		description: "Specifies the white space between words",
		link: "https://www.w3schools.com/cssref/pr_text_word-spacing.asp",
		propertyName: "word-spacing",
		valuetemplate: "{0}",
		categories: [
			"container",
			"word"
		],
		tags: "container,word",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Custom",
						valuetemplate: "{0}px",
						value: {
							controls: [
								{
									type: "number",
									label: "Length"
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Word Wrap",
		description: "Allows long words to be able to be broken and wrap onto the next line",
		link: "https://www.w3schools.com/cssref/css3_pr_word-wrap.asp",
		propertyName: "word-wrap",
		valuetemplate: "{0}",
		categories: [
			"container",
			"word"
		],
		tags: "container,word",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Value",
				options: [
					{
						name: "Normal",
						value: "normal"
					},
					{
						name: "Break Word",
						value: "break-word"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Writing Mode",
		description: "Specifies whether lines of text are laid out horizontally or vertically",
		link: "https://www.w3schools.com/cssref/css3_pr_writing-mode.asp",
		propertyName: "writing-mode",
		valuetemplate: "{0}",
		categories: [
			"alignment",
			"layout",
			"position"
		],
		tags: "alignment,layout,position",
		controls: [
			{
				type: "select",
				"default": "horizontal-tb",
				label: "Value",
				options: [
					{
						name: "Horizontal content flow, top to bottom",
						value: "horizontal-tb"
					},
					{
						name: "Vertical content flow, right to left",
						value: "vertical-rl"
					},
					{
						name: "Vertical content flow, left to right",
						value: "vertical-lr"
					}
				]
			}
		]
	}
];

var z = [
	{
		display: "Stack Order",
		description: "Specifies the stack order of an element. Higher stack order gets priority over lower order in case of rendering.",
		link: "https://www.w3schools.com/cssref/pr_pos_z-index.asp",
		propertyName: "z-index",
		valuetemplate: "{0}",
		categories: [
			"container",
			"alignment"
		],
		tags: "container",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Value",
				options: [
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "number",
									label: "Count"
								}
							]
						}
					}
				]
			}
		]
	}
];

var h = [
	{
		display: "Place the punctuation",
		description: "The hanging-punctuation property specifies whether a punctuation mark may be placed outside the line box at the start or at the end of a full line of text.",
		link: "https://www.w3schools.com/cssref/css3_pr_hanging-punctuation.asp",
		propertyName: "hanging-punctuation",
		valuetemplate: "{0}",
		categories: [
			"misc"
		],
		tags: "punctuation, character, paragraph",
		controls: [
			{
				type: "select",
				"default": "none",
				label: "Value",
				options: [
					{
						name: "No Punctuation",
						value: "none"
					},
					{
						name: "At the First",
						value: "first"
					},
					{
						name: "At the Last",
						value: "last"
					},
					{
						name: "Allow at the End",
						value: "allow-end"
					},
					{
						name: "Force at the End",
						value: "force-end"
					},
					{
						name: "Default Value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Set the height",
		description: "The height property sets the height of an element. The height of an element does not include padding, borders, or margins!",
		link: "https://www.w3schools.com/cssref/pr_dim_height.asp",
		propertyName: "height",
		valuetemplate: "{0}",
		categories: [
			"misc",
			"layout",
			"container"
		],
		tags: "size, height, scale",
		controls: [
			{
				type: "select",
				"default": "auto",
				label: "Value",
				options: [
					{
						name: "Auto",
						value: "auto"
					},
					{
						name: "Default Value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							valuetemplate: "{0}{1}",
							controls: [
								{
									type: "number",
									label: "Value"
								},
								{
									type: "select",
									"default": "px",
									label: "Unit",
									options: [
										{
											name: "Pixels",
											value: "px"
										},
										{
											name: "Percent",
											value: "%"
										},
										{
											name: "Em",
											value: "em"
										},
										{
											name: "Rem",
											value: "rem"
										}
									]
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Allow hyphens to wrap text",
		description: "The hyphens property defines whether hyphenation is allowed to create more soft wrap opportunities within a line of text.",
		link: "https://www.w3schools.com/cssref/css3_pr_hanging-punctuation.asp",
		propertyName: "hyphens",
		valuetemplate: "{0}",
		categories: [
			"misc",
			"layout",
			"container"
		],
		tags: "wrap, layout",
		controls: [
			{
				type: "select",
				"default": "none",
				label: "Value",
				options: [
					{
						name: "No hypens",
						value: "none"
					},
					{
						name: "Words wrapped at '-' symbol",
						value: "manual"
					},
					{
						name: "Words wrapped automatically",
						value: "auto"
					},
					{
						name: "Default Value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

var a = [
	{
		display: "Set all properties",
		description: "Resets all properties (except unicode-bidi and direction)",
		link: "https://www.w3schools.com/cssref/css3_pr_all.asp",
		propertyName: "all",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "all",
		controls: [
			{
				type: "select",
				"default": "none",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					},
					{
						name: "Unset",
						value: "unset"
					},
					{
						name: "None",
						value: ""
					}
				]
			}
		]
	},
	{
		display: "Align Content",
		description: "Specifies the alignment between the lines inside a flexible container when the items do not use all available space",
		link: "https://www.w3schools.com/cssref/css3_pr_align-content.asp",
		propertyName: "align-content",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "alignment,layout,position",
		controls: [
			{
				type: "select",
				"default": "stretch",
				label: "Alignment",
				options: [
					{
						name: "Stretch",
						value: "stretch"
					},
					{
						name: "Center",
						value: "center"
					},
					{
						name: "Start",
						value: "flex-start"
					},
					{
						name: "End",
						value: "flex-end"
					},
					{
						name: "Evenly Distributed",
						value: "space-between"
					},
					{
						name: "Evenly Distributed with padding",
						value: "space-around"
					},
					{
						name: "Evenly Distributed with padding both side",
						value: "space-evenly"
					},
					{
						name: "Default",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Align Items",
		description: "Specifies the alignment for items inside a flexible container",
		link: "https://www.w3schools.com/cssref/css3_pr_align-items.asp",
		propertyName: "align-items",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "alignment,layout,position",
		controls: [
			{
				type: "select",
				label: "Alignment",
				"default": "stretch",
				options: [
					{
						name: "Stretch",
						value: "stretch"
					},
					{
						name: "Center",
						value: "center"
					},
					{
						name: "Start",
						value: "flex-start"
					},
					{
						name: "End",
						value: "flex-end"
					},
					{
						name: "Align to baseline of container",
						value: "baseline"
					},
					{
						name: "Default",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Animation",
		description: "Prepares animation for selected object",
		propertyName: "animation",
		valuetemplate: "{0} {1} {2} {3} {4} {5} {6} {7}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				description: "Specifies the name of the keyframe you want to bind to the selector",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-name.asp",
				"default": "",
				label: "Animation Name",
				valuetemplate: "{0} ",
				options: [
					{
						name: "None",
						value: ""
					},
					{
						name: "Initial",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							valuetemplate: "{0}s",
							controls: [
								{
									type: "text",
									label: "Custom Name"
								}
							]
						}
					}
				]
			},
			{
				type: "select",
				"default": "",
				label: "Animation Duration",
				description: "Specifies how many seconds or milliseconds an animation takes to complete",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-duration.asp",
				valuetemplate: "{0}",
				options: [
					{
						name: "initial",
						value: "initial"
					},
					{
						name: "inherit",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "number",
									label: "In Seconds",
									valuetemplate: "{0} "
								}
							]
						}
					}
				]
			},
			{
				type: "select",
				"default": "ease",
				label: "Timing Function",
				description: "Specifies the speed curve of the animation",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-timing-function.asp",
				valuetemplate: "{0}",
				options: [
					{
						name: "Consistent Speed",
						value: "linear"
					},
					{
						name: "Slow-Fast-Slow",
						value: "ease"
					},
					{
						name: "Slow start",
						value: "ease-in"
					},
					{
						name: "Slow end",
						value: "ease-out"
					},
					{
						name: "Slow start | Slow end",
						value: "ease-in-out"
					},
					{
						name: "Start step with one",
						value: "step-start"
					},
					{
						name: "End step with one",
						value: "step-end"
					},
					{
						name: "Steps",
						valuetemplate: "steps({0},{1})",
						value: {
							controls: [
								{
									type: "number",
									label: "Steps"
								},
								{
									type: "select",
									label: "Position",
									options: [
										{
											name: "Start",
											value: "start"
										},
										{
											name: "End",
											value: "end"
										}
									]
								}
							]
						}
					},
					{
						name: "Cube",
						valuetemplate: "cubic-bezier({0},{1},{2},{3})",
						value: {
							controls: [
								{
									type: "number",
									label: "Step 1",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 2",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 3",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 4",
									min: "0",
									max: "100",
									multiplier: 0.01
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					}
				]
			},
			{
				type: "select",
				"default": "0",
				label: "Delay",
				description: "Specifies a delay before the animation will start",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-delay.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Custom",
						valuetemplate: "{0}s",
						value: {
							controls: [
								{
									type: "number",
									label: "Time(secs)"
								}
							]
						}
					}
				]
			},
			{
				type: "select",
				"default": "1",
				label: "Animation Repetition",
				description: "Specifies how many times an animation should be played",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-iteration-count.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Infinitely",
						value: "infinite"
					},
					{
						name: "Custom Repeat Count",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "number",
									label: "Repeat Count"
								}
							]
						}
					}
				]
			},
			{
				type: "select",
				"default": "normal",
				label: "Direction",
				description: "Specifies whether or not the animation should play in reverse on alternate cycles",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-direction.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Normal Direction",
						value: "normal"
					},
					{
						name: "Alternate Direction",
						value: "alternate"
					},
					{
						name: "Alternate Reverse Direction",
						value: "alternate-reverse"
					}
				]
			},
			{
				type: "select",
				"default": "none",
				label: "Animation Fill Mode",
				description: "Specifies what values are applied by the animation outside the time it is executing",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-fill-mode.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "No fille mode",
						value: "none"
					},
					{
						name: "From last keyframe",
						value: "forwards"
					},
					{
						name: "From first keyframe",
						value: "backwards"
					},
					{
						name: "Both from first and last",
						value: "both"
					}
				]
			},
			{
				type: "select",
				"default": "running",
				label: "Play State",
				description: "Specifies whether the animation is running or paused",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-play-state.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Paused",
						value: "paused"
					},
					{
						name: "Running",
						value: "running"
					}
				]
			}
		]
	},
	{
		display: "Self Align",
		description: "Specifies the alignment for selected items inside a flexible container",
		propertyName: "align-self",
		valuetemplate: "{0}",
		categories: [
			"alignment"
		],
		tags: "alignment,layout,position",
		controls: [
			{
				type: "select",
				"default": "auto",
				options: [
					{
						name: "Automatic",
						value: "auto"
					},
					{
						name: "Stretched",
						value: "stretch"
					},
					{
						name: "Centered",
						value: "center"
					},
					{
						name: "Beginning of container",
						value: "flex-start"
					},
					{
						name: "End of container",
						value: "flex-end"
					},
					{
						name: "Baseline of container",
						value: "baseline"
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "Inherit from parent",
						value: "inherit"
					}
				]
			}
		]
	},
	{
		display: "Animation: Delay",
		description: "Specifies a delay for the start of an animation",
		propertyName: "animation-delay",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-delay.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "0",
				label: "Delay",
				description: "Specifies a delay before the animation will start",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-delay.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Custom",
						valuetemplate: "{0}s",
						value: {
							controls: [
								{
									type: "number",
									label: "Time(secs)"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Animation: Direction",
		description: "Specifies whether an animation should be played forwards, backwards or in alternate cycles",
		propertyName: "animation-direction",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-direction.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "normal",
				label: "Direction",
				description: "Specifies whether or not the animation should play in reverse on alternate cycles",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-direction.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Normal Direction",
						value: "normal"
					},
					{
						name: "Alternate Direction",
						value: "alternate"
					},
					{
						name: "Alternate Reverse Direction",
						value: "alternate-reverse"
					}
				]
			}
		]
	},
	{
		display: "Animation: Duration",
		description: "Specifies how long an animation should take to complete one cycle",
		propertyName: "animation-duration",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-duration.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "",
				label: "Animation Duration",
				description: "Specifies how many seconds or milliseconds an animation takes to complete",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-duration.asp",
				valuetemplate: "{0}",
				options: [
					{
						name: "initial",
						value: "initial"
					},
					{
						name: "inherit",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							controls: [
								{
									type: "number",
									label: "In Seconds",
									valuetemplate: "{0}s"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Animation: Fill Mode",
		description: "Specifies a style for the element when the animation is not playing (before it starts, after it ends, or both)",
		propertyName: "animation-fill-mode",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-fill-mode.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "none",
				label: "Animation Fill Mode",
				description: "Specifies what values are applied by the animation outside the time it is executing",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-fill-mode.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "No fille mode",
						value: "none"
					},
					{
						name: "From last keyframe",
						value: "forwards"
					},
					{
						name: "From first keyframe",
						value: "backwards"
					},
					{
						name: "Both from first and last",
						value: "both"
					}
				]
			}
		]
	},
	{
		display: "Animation: Iteration",
		description: "Specifies the number of times an animation should be played",
		propertyName: "animation-iteration-count",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-iteration-count.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "1",
				label: "Animation Repetition",
				description: "Specifies how many times an animation should be played",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-iteration-count.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Infinitely",
						value: "infinite"
					},
					{
						name: "Custom Repeat Count",
						valuetemplate: "{0}",
						value: {
							controls: [
								{
									type: "number",
									label: "Repeat Count"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Animation: Name",
		description: "Specifies a name for the @keyframes animation",
		propertyName: "animation-name",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-name.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				description: "Specifies the name of the keyframe you want to bind to the selector",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-name.asp",
				"default": "",
				label: "Animation Name",
				valuetemplate: "{0} ",
				options: [
					{
						name: "None",
						value: ""
					},
					{
						name: "Initial",
						value: "initial"
					},
					{
						name: "Inherit",
						value: "inherit"
					},
					{
						name: "Custom",
						value: {
							valuetemplate: "{0}s",
							controls: [
								{
									type: "text",
									label: "Custom Name"
								}
							]
						}
					}
				]
			}
		]
	},
	{
		display: "Animation: Play State",
		description: "Specifies whether the animation is running or paused",
		propertyName: "animation-play-state",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-play-state.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "running",
				label: "Play State",
				description: "Specifies whether the animation is running or paused",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-play-state.asp",
				options: [
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					},
					{
						name: "Paused",
						value: "paused"
					},
					{
						name: "Running",
						value: "running"
					}
				]
			}
		]
	},
	{
		display: "Animation: Timing Function",
		description: "Specifies the speed curve of an animation",
		propertyName: "animation-timing-function",
		valuetemplate: "{0}",
		link: "https://www.w3schools.com/cssref/css3_pr_animation-timing-function.asp",
		categories: [
			"animation"
		],
		tags: "animation",
		controls: [
			{
				type: "select",
				"default": "ease",
				label: "Timing Function",
				description: "Specifies the speed curve of the animation",
				link: "https://www.w3schools.com/cssref/css3_pr_animation-timing-function.asp",
				valuetemplate: "{0}",
				options: [
					{
						name: "Consistent Speed",
						value: "linear"
					},
					{
						name: "Slow-Fast-Slow",
						value: "ease"
					},
					{
						name: "Slow start",
						value: "ease-in"
					},
					{
						name: "Slow end",
						value: "ease-out"
					},
					{
						name: "Slow start | Slow end",
						value: "ease-in-out"
					},
					{
						name: "Start step with one",
						value: "step-start"
					},
					{
						name: "End step with one",
						value: "step-end"
					},
					{
						name: "Steps",
						valuetemplate: "steps({0},{1})",
						value: {
							controls: [
								{
									type: "number",
									label: "Steps"
								},
								{
									type: "select",
									label: "Position",
									options: [
										{
											name: "Start",
											value: "start"
										},
										{
											name: "End",
											value: "end"
										}
									]
								}
							]
						}
					},
					{
						name: "Cube",
						valuetemplate: "cubic-bezier({0},{1},{2},{3})",
						value: {
							controls: [
								{
									type: "number",
									label: "Step 1",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 2",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 3",
									min: "0",
									max: "100",
									multiplier: 0.01
								},
								{
									type: "number",
									label: "Step 4",
									min: "0",
									max: "100",
									multiplier: 0.01
								}
							]
						}
					},
					{
						name: "Default value",
						value: "initial"
					},
					{
						name: "From parent",
						value: "inherit"
					}
				]
			}
		]
	}
];

const Templates = a.concat(b, c, d, h, j, u, v, w, z);

let _ = t => t,
    _t,
    _t2,
    _t3,
    _t4,
    _t5,
    _t6,
    _t7,
    _t8,
    _t9,
    _t10,
    _t11,
    _t12,
    _t13,
    _t14,
    _t15,
    _t16,
    _t17;
const fadeIn = keyframes(_t || (_t = _`
  0% {
    opacity: 0;
  }
  100% {
    opacity: 100%;
  }
`));
const CBSimpleButton = styled.input(_t2 || (_t2 = _`
  padding: 8px;
  background-color: transparent;
  border: none;
  border-radius: 3px;
  letter-spacing: 0.2em;
  transition: all 0.2s cubic-bezier(0.4, 0, 0.2, 1);
  cursor: pointer;
  border: 1px solid ${0};
  color: ${0};
  display: block;
  &:hover {
    /* letter-spacing: 0.8em; */
    border-left: 10px solid ${0};
  }
`), ({
  theme
}) => theme.colors.button.borderColor, ({
  theme
}) => theme.colors.color, ({
  theme
}) => theme.colors.button.borderColor);
const CBAccordion = styled.div(_t3 || (_t3 = _`
  color: ${0};
  > div > div:first-of-type {
    padding: 1em;
    color: ${0};
    text-transform: uppercase;
    user-select: none;
    font-weight: 200;
    cursor: pointer;
    background-color: ${0};
    border: 1px solid ${0};
  }
  > div > div:last-of-type {
    background-color: ${0};
    margin: 0 0.5em;
    box-shadow: 0 0 20px 2px ${0};
  }
  .cb_accordion_item {
    padding: 1em;
    // opacity: 0;
    transition: opacity 300ms ease;
    overflow: auto;
  }
  > div:first-child .cb_accordion_item {
    max-height: 200px;
  }
  > div.open .cb_accordion_item {
    opacity: 1;
    transition: opacity 700ms ease;
  }
  img.cb_accordion_item {
    padding: 0;
    margin: 0;
    width: 100%;
  }
`), ({
  theme
}) => theme.colors.color, ({
  theme
}) => theme.colors.color, ({
  theme
}) => theme.colors.background, ({
  theme
}) => theme.colors.accordion.border, ({
  theme
}) => theme.colors.accordion.background, ({
  theme
}) => theme.colors.accordion.shadow);
const CBToolbarButton = styled.button(_t4 || (_t4 = _`
  padding: 4px 10px;
  font: 13px 'Montserrat';
  font-weight: 700;
  letter-spacing: 2px;
  text-transform: uppercase;
  text-decoration: none;
  text-align: center;
  opacity: 0.5;
  color: ${0};
  background-color: transparent;
  transition: 0.2s ease-in-out;
  border: 0;
  border-bottom: transparent 3px solid;
  border-radius: 0px;
  cursor: pointer;
  &:hover {
    opacity: 1;
    background-color: transparent;
    border-bottom: ${0} 3px solid;
  }
`), ({
  theme
}) => theme.colors.color, ({
  theme
}) => theme.colors.color);
const CBToolbarAnchor = styled.a(_t5 || (_t5 = _`
  padding: 4px 10px;
  font: 13px 'Montserrat';
  font-weight: 700;
  letter-spacing: 2px;
  text-transform: uppercase;
  text-decoration: none;
  text-align: center;
  opacity: 0.5;
  color: ${0};
  background-color: transparent;
  transition: 0.2s ease-in-out;
  border: 0;
  border-bottom: transparent 3px solid;
  border-radius: 0px;
  cursor: pointer;
  &:hover {
    opacity: 1;
    background-color: transparent;
    border-bottom: ${0} 3px solid;
  }
`), ({
  theme
}) => theme.colors.color, ({
  theme
}) => theme.colors.color);
const CBGridRow = styled.div(_t6 || (_t6 = _`
  display: grid;
  width: 100%;
  color: ${0};
`), ({
  theme
}) => theme.colors.color);
const CBGridCell = styled.div(_t7 || (_t7 = _`
  width: 100%;
  margin-bottom: 1rem;
  > div {
    border: 1px solid ${0};
    width: 100%;
    height: 30px;
    display: flex;
    align-items: center;
    padding: 0 1rem;
    box-sizing: border-box;
    &:nth-child(2) {
      &:hover {
        border-color: ${0};
      }
    }
    &:nth-child(1) {
      border-left: 10px solid ${0};
      font-weight: 500;
    }

    // justify-content: center;
  }
`), ({
  theme
}) => theme.colors.border, ({
  theme
}) => theme.colors.borderDark, ({
  theme
}) => theme.colors.border);
const CBInput = styled.input(_t8 || (_t8 = _`
  border: none;
  outline: none;
  height: 100%;
  width: 100%;
  font-family: inherit;
`));
const CBSelect = styled.select(_t9 || (_t9 = _`
  border: none;
  outline: none;
  height: 100%;
  width: 100%;
  font-family: inherit;
`));
const CBHelpTip = styled.div(_t10 || (_t10 = _`
  margin: auto;
  text-align: center;
  border: 2px solid ${0};
  border-radius: 50%;
  width: 20px;
  height: 20px;
  font-size: 10px;
  line-height: 20px;
  cursor: pointer;

  &:before {
    content: '?';
    font-family: sans-serif;
    font-weight: 700;
    font-size: 15px;
    color: ${0};
  }

  &:hover p {
    display: block;

    transform-origin: 100% 0%;
    -webkit-animation: ${0} 0.3s ease;
    animation: ${0} 0.3s ease;
  }

  p {
    display: none;
    font-family: sans-serif;
    text-rendering: optimizeLegibility;
    -webkit-font-smoothing: antialiased;
    text-align: center;
    background-color: ${0};
    padding: 12px 16px;
    z-index: 999999;
    width: 178px;
    height: auto;
    position: absolute;
    //   left: 80%;
    transform: translate(-45%, 5%);
    border-radius: 3px;
    /* 	border: 1px solid #E0E0E0; */
    box-shadow: 0 0px 20px 0 rgba(0, 0, 0, 0.1);
    color: ${0};
    font-size: 12px;
    line-height: 18px;
    z-index: 99;
    a {
      color: ${0};
      text-decoration: none;
      &:hover {
        text-decoration: underline;
      }
    }
    &:before {
      position: absolute;
      content: '';
      width: 0;
      height: 0;
      border: 10px solid transparent;
      border-bottom-color: ${0};
      top: -9px;
      left: 50%;
      transform: translate(-50%, -50%);
    }
    &:after {
      width: 10px;
      height: 40px;
      content: '';
      position: absolute;
      top: -40px;
      left: 0;
    }
  }
`), ({
  theme
}) => theme.colors.border, ({
  theme
}) => theme.colors.highlight, fadeIn, fadeIn, ({
  theme
}) => theme.colors.background, ({
  theme
}) => theme.colors.color, ({
  theme
}) => theme.colors.highlight, ({
  theme
}) => theme.colors.border);
const modalShowStyle = css(_t11 || (_t11 = _`
  top: 0;
`));
const CBModal = styled.div(_t12 || (_t12 = _`
  display: block;
  position: fixed;

  top: 0;
  left: 0;
  width: 100vw !important;
  height: 100vh !important;
  z-index: 999;
  -webkit-backdrop-filter: blur(10px);
  backdrop-filter: blur(10px);
  display: flex;
  align-items: center;
  justify-content: center;
  div {
    overflow: hidden !important;
    box-sizing: border-box;
  }
  > div {
    background: ${0};
    border: 2px solid ${0};
    width: 90%;
    height: 80%;
    border-radius: 8px;
    > div {
      display: flex;
      flex-direction: column;
      box-sizing: border-box;
      height: 100%;
      padding: 1rem;
    }
  }

  ${0}
`), ({
  theme
}) => theme.colors.background, ({
  theme
}) => theme.colors.border, props => props.state === '1' && modalShowStyle);
const CBAttributeRow = styled.div(_t13 || (_t13 = _`
  cursor: pointer;
  border-left: 4px solid transparent;
  height: 40px;
  padding: 0px 1rem;
  &:hover {
    border-color: ${0};
    background-color: ${0};
  }
  > div {
    display: flex;
    align-items: center;
  }
`), ({
  theme
}) => theme.colors.highlight, ({
  theme
}) => theme.colors.background);
const CBTabContainer = styled.div(_t14 || (_t14 = _`
  display: flex;
  ul {
    display: flex;
    flex-direction: column;
    border-right: 1px solid ${0};
    padding: 0 1rem 0rem 0;
  }
  > div {
    padding: 1rem;
    display: flex;
    flex-direction: column;
    height: 100%;
    > div {
      overflow: auto !important;
      > div {
        &:nth-child(2) {
          height: 100%;
        }
      }
    }
  }
`), ({
  theme
}) => theme.colors.border);
const CBFilterInput = styled.input(_t15 || (_t15 = _`
  font-size: 12px;
  display: block;
  width: 100%;
  height: 36px;
  padding: 0 20px;
  background: ${0};
  color: ${0};
  border: 1px solid #3d85d8;
  border-radius: 4px;
  box-sizing: border-box;
  &:focus {
    outline: none;
    ~ .cb_floating_label {
      top: -8px;
      font-size: 13px;
    }
  }
`), ({
  theme
}) => theme.colors.background, ({
  theme
}) => theme.colors.color);
const CBTab = styled.div(_t16 || (_t16 = _`
  width: 100%;
  padding: 25px;
  font-family: sans-serif;
  color: ${0};
  ul.inline {
    list-style: none;
    padding: 0;
    margin-bottom: 0;
    -webkit-margin-before: 0;
    -webkit-margin-after: 0;
    -webkit-margin-start: 0px;
    -webkit-margin-end: 0px;
    -webkit-padding-start: 0px;
  }
`), ({
  theme
}) => theme.colors.color);
const CBTabPanelList = styled.li(_t17 || (_t17 = _`
  display: inline-block;
  margin-left: 0;
  padding: 10px;
  border-bottom: 2px solid ${0};
  transition: all 0.5s;
  font-family: Lato, sans-serif;
  font-weight: 300;
  cursor: pointer;
  text-transform: capitalize;
  color: ${0};
  opacity: ${0};
  border-right: 4px solid
    ${0};
`), ({
  theme
}) => theme.colors.border, ({
  theme
}) => theme.colors.color, props => props.selected ? '1' : '0.5', props => props.selected ? props.theme.colors.highlight : 'transparent');

class Tabs extends Component {
  constructor(...args) {
    super(...args);
    this.state = {
      selected: this.props.selected || 0
    };
  }

  handleChange(index) {
    this.setState({
      selected: index
    });
  }

  render() {
    return /*#__PURE__*/React__default.createElement(Fragment, null, /*#__PURE__*/React__default.createElement("ul", null, this.props.children.map((elem, index) => {
      return /*#__PURE__*/React__default.createElement(CBTabPanelList, {
        key: index,
        selected: index === this.state.selected,
        onClick: () => this.handleChange(index)
      }, elem.props.title);
    })), /*#__PURE__*/React__default.createElement(CBTab, null, this.props.children[this.state.selected]));
  }

}

function Panel(props) {
  console.log("Panel props.children: ", props.children);
  return /*#__PURE__*/React__default.createElement("div", null, props.children);
}

const PropertyBrowser = ({
  selected,
  onChange,
  onClose,
  show,
  ...rest
}) => {
  const [allProps, setAllProps] = useState([]);
  const [sortedProps, setSortedProps] = useState({});
  useEffect(() => {
    let res = prepareList(Templates);
    setSortedProps(res);
  }, []);

  const onRowClicked = val => {
    if (onChange) {
      onChange(val);
    }
  };

  const onFilterTextChanged = val => {
    setSortedProps(prepareList(Templates.filter(t => {
      return t.display.indexOf(val) > -1 || t.description.indexOf(val) > -1 || t.propertyName.indexOf(val) > -1;
    })));
  };

  const prepareList = list => {
    let res = {};
    res['#All'] = {};
    list.forEach(t => {
      const index = t.display.substring(0, 1);
      res['#All'][index] = res['#All'][index] || [];
      res['#All'][index].push(t);
      t.categories.forEach(c => {
        res[c] = res[c] || {};
        res[c][index] = res[c][index] || [];
        res[c][index].push(t);
      });
    });
    res = Object.keys(res).sort().reduce(function (result, key) {
      result[key] = res[key];
      return result;
    }, {});
    return res;
  };

  return /*#__PURE__*/createElement(CBModal, {
    state: show ? '1' : '0',
    onClick: () => onClose()
  }, /*#__PURE__*/createElement("div", {
    onClick: e => {
      e.stopPropagation();
      e.preventDefault();
    }
  }, /*#__PURE__*/createElement("div", null, /*#__PURE__*/createElement("div", {
    style: {
      display: 'flex',
      height: '70px'
    }
  }, /*#__PURE__*/createElement("div", {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/createElement("h1", null, " CSS Attribute Browser")), /*#__PURE__*/createElement("div", null, /*#__PURE__*/createElement("input", {
    type: "button",
    value: "close",
    onClick: () => onClose()
  }), ' ')), /*#__PURE__*/createElement("div", {
    style: {
      height: '60px'
    }
  }, /*#__PURE__*/createElement(CBFilterInput, {
    type: "text",
    placeholder: "FILTER",
    onChange: e => onFilterTextChanged(e.target.value)
  })), /*#__PURE__*/createElement(CBTabContainer, {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/createElement(Tabs, null, Object.keys(sortedProps).sort().map((catkey, cati) => {
    return /*#__PURE__*/createElement(Panel, {
      title: catkey,
      key: cati
    }, /*#__PURE__*/createElement("div", {
      style: {
        overflow: 'auto !important'
      }
    }, Object.keys(sortedProps[catkey]).sort().map((index, indexi) => {
      return /*#__PURE__*/createElement("div", {
        key: indexi
      }, /*#__PURE__*/createElement("div", null, /*#__PURE__*/createElement("label", null, index)), /*#__PURE__*/createElement("div", null, sortedProps[catkey][index].map((c, ci) => {
        return /*#__PURE__*/createElement(CBAttributeRow, {
          style: {
            display: 'flex'
          },
          onClick: () => onRowClicked(c),
          key: ci
        }, /*#__PURE__*/createElement("div", {
          style: {
            width: '20%'
          }
        }, c.display), /*#__PURE__*/createElement("div", {
          style: {
            flex: 1
          }
        }, c.description));
      })));
    })));
  }))))));
};

const ControlTemplate = ({
  field,
  onChange
}) => {
  const [fieldData, setFieldData] = useState({});
  const [subFiledValues, setSubFieldValues] = useState([]);
  useEffect(() => {
    setFieldData(field || {});
  }, [field]);

  const onPropertyValueChange = value => {
    fieldData.value = value;
    setFieldData({ ...fieldData
    });

    if (onChange) {
      if (typeof fieldData.value === 'string' && fieldData.value.indexOf("{") === 0) {
        const v = JSON.parse(fieldData.value);

        if (typeof v.value === 'string' && v.value.indexOf("{")) ; else {
          onChange((fieldData.valuetemplate || '{0}').replace(`{${0}}`, v.value));
        }
      } else {
        onChange((fieldData.valuetemplate || '{0}').replace(`{${0}}`, value));
      }
    }
  };

  const onSubControlValueChanged = (control, value, index, f) => {
    let res = f.valuetemplate || "{0}";

    for (var i = 0; i <= index; i++) {
      subFiledValues[i] = subFiledValues[i] || '';
    }

    subFiledValues[index] = value;

    for (var j = 0; j < subFiledValues.length; j++) {
      res = res.replace(`{${j}}`, subFiledValues[j]);
    }

    if (onChange) {
      onChange(res);
    }
  };

  const getSubControls = () => {
    const res = [];

    if (fieldData.value && typeof fieldData.value === 'string' && fieldData.value.indexOf("{") === 0) {
      const obj = JSON.parse(fieldData.value);
      obj.value.controls.forEach((c, ci) => {
        res.push( /*#__PURE__*/React__default.createElement(ControlTemplate, {
          field: c,
          onChange: val => {
            onSubControlValueChanged(c, val, ci, obj);
          }
        }));
      });
    }

    return res;
  };

  const getControl = () => {
    let res = [];
    let output = [];

    switch (fieldData.type) {
      case 'select':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          className: "cb-floating-label-content",
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBSelect, {
          className: "cb-floating-select",
          value: fieldData.value,
          onChange: e => onPropertyValueChange(e.target.value),
          style: {
            width: '100%'
          }
        }, fieldData.options.map((o, oi) => {
          return /*#__PURE__*/React__default.createElement("option", {
            value: typeof o.value === 'object' ? JSON.stringify(o) : o.value,
            key: oi
          }, `${o.name}`);
        }))));
        break;

      case 'radio':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          className: "radio-toolbar",
          style: {
            flex: 1
          }
        }, fieldData.options.map((o, oi) => {
          return /*#__PURE__*/React__default.createElement(Fragment, {
            key: oi
          }, /*#__PURE__*/React__default.createElement(CBInput, {
            type: "radio",
            id: `radio-${o.name}`,
            name: `radio-${o.name}`,
            value: o.value,
            checked: o.value === fieldData.value
          }), /*#__PURE__*/React__default.createElement("label", {
            for: "radioBanana"
          }, o.name));
        })));
        break;

      case 'color':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBInput, {
          type: "color",
          id: "favcolor",
          name: "favcolor",
          value: fieldData.value,
          style: {
            padding: '0px',
            border: 'none',
            width: '100%',
            height: '20px'
          },
          onChange: e => onPropertyValueChange(e.target.value)
        })));
        break;

      case 'number':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBInput, {
          type: "number",
          id: "favcolor",
          name: "favcolor",
          value: fieldData.value,
          onChange: e => onPropertyValueChange(e.target.value)
        })));
        break;

      case 'range':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBInput, {
          type: "range",
          min: fieldData.min || '1',
          max: fieldData.max || '100',
          value: fieldData.value,
          style: {
            width: '100%'
          },
          onChange: e => onPropertyValueChange(e.target.value * (fieldData.multiplier || 1))
        })));
        break;

      case 'text':
        output.push( /*#__PURE__*/React__default.createElement("div", {
          style: {
            flex: 1
          }
        }, /*#__PURE__*/React__default.createElement(CBInput, {
          type: "text",
          id: "favcolor",
          name: "favcolor",
          placeholder: fieldData.label,
          value: fieldData.value,
          onChange: e => onPropertyValueChange(e.target.value)
        })));
    }

    res = res.concat([/*#__PURE__*/React__default.createElement(CBGridCell, null, /*#__PURE__*/React__default.createElement("div", {
      style: {
        flex: 1,
        display: 'flex'
      }
    }, /*#__PURE__*/React__default.createElement("div", {
      style: {
        flex: 1
      }
    }, fieldData.label), /*#__PURE__*/React__default.createElement(CBHelpTip, null, /*#__PURE__*/React__default.createElement("p", null, fieldData.description, /*#__PURE__*/React__default.createElement("br", null), /*#__PURE__*/React__default.createElement("span", {
      style: {
        fontWeight: '500'
      }
    }, "Default: "), fieldData.default, /*#__PURE__*/React__default.createElement("br", null), /*#__PURE__*/React__default.createElement("a", {
      href: fieldData.link || 'https://www.w3schools.com/cssref/',
      target: "_blank"
    }, "W3School Definition")))), /*#__PURE__*/React__default.createElement("div", null, output))]);
    res = res.concat(getSubControls());
    return res;
  };

  const allcontrols = getControl();
  return /*#__PURE__*/React__default.createElement(CBGridRow, {
    style: {
      gridTemplateColumns: `repeat(${allcontrols.length}, 1fr)`
    }
  }, getControl());
};

class Accordion extends React__default.Component {
  constructor(props) {
    super(props);
    this.state = {
      index: typeof props.selectedIndex !== 'undefined' ? props.selectedIndex : -1
    };
    this.nodes = [];
  }

  componentWillReceiveProps(props) {
    if (typeof props.selectedIndex !== 'undefined' && this.state.index !== props.selectedIndex) {
      this.toggle(props.selectedIndex);
    }
  }

  componentWillUnmount() {
    clearTimeout(this.timeout);
  }

  toggle(index, click) {
    clearTimeout(this.timeout);

    if (click) {
      if (this.props.onChange) this.props.onChange(index, this.state.index !== index, this.state.index !== index ? index : -1);
      if (!this.props.changeOnClick) return;
    }

    if (this.state.index > -1) {
      const content = this.nodes[this.state.index].ref.children[1];
      content.style.height = `${content.children[0].offsetHeight}px`;
    }

    if (this.state.index === index || index === -1) {
      setTimeout(() => {
        this.setState({
          index: -1
        });
      }, 50);
    } else {
      setTimeout(() => {
        this.setState({
          index
        });
        this.timeout = setTimeout(() => {
          this.nodes[index].ref.children[1].style.height = 'auto';
        }, this.props.transitionDuration);
      }, 50);
    }
  }

  getHeight(index) {
    if (index === this.state.index) {
      return this.nodes.length > index ? this.nodes[index].ref.children[1].children[0].offsetHeight : 'auto';
    }

    return 0;
  }

  render() {
    const style = {
      overflow: 'hidden',
      transition: `height ${this.props.transitionDuration}ms ${this.props.transitionTimingFunction}`
    };
    const nodes = React__default.Children.map(this.props.children, (child, index) => /*#__PURE__*/React__default.createElement("div", {
      key: index,
      ref: div => {
        this.nodes[index] = {
          ref: div
        };
      },
      className: this.state.index === index ? this.props.openClassName : ''
    }, /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        height: '100%',
        width: '100%',
        boxSizing: "border-box"
      }
    }, /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'center',
        width: '50px',
        height: '100%'
      }
    }, /*#__PURE__*/React__default.createElement("div", null)), /*#__PURE__*/React__default.createElement("div", {
      onClick: () => this.toggle(index, true),
      style: {
        flex: 1
      }
    }, child.props['data-header']), /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(CBToolbarAnchor, {
      href: child.props['help-link'],
      target: "_blank"
    }, "Help"), /*#__PURE__*/React__default.createElement(CBToolbarButton, {
      type: "button",
      onClick: () => child.props['on-change-clicked']()
    }, "Change"), /*#__PURE__*/React__default.createElement(CBToolbarButton, {
      type: "button",
      onClick: () => child.props['on-remove-clicked']()
    }, "Remove"))), /*#__PURE__*/React__default.createElement("div", {
      style: { ...style,
        height: this.getHeight(index)
      }
    }, child)));
    return /*#__PURE__*/React__default.createElement(CBAccordion, null, nodes);
  }

}

Accordion.defaultProps = {
  transitionDuration: 500,
  transitionTimingFunction: 'ease',
  openClassName: 'open',
  changeOnClick: true
};

const dark = {
  meta: {
    name: 'dark',
    displayName: 'Dark'
  },
  colors: {
    background: '#121212',
    color: '#FFF',
    border: '#454545',
    borderDark: '#202125',
    highlight: '#7bc5ee',
    button: {
      borderColor: '#FFF'
    },
    accordion: {
      background: '#121212',
      shadow: '#FFF',
      border: '#EFEFEF'
    }
  }
};

const chalk = {
  meta: {
    name: 'chalk',
    displayName: 'Chalk'
  },
  colors: {
    background: '#FFF',
    color: '#454545',
    border: '#cdcdcd',
    borderDark: '#454545',
    highlight: '#067df7',
    button: {
      borderColor: '#454545'
    },
    accordion: {
      background: '#f9f9f9',
      shadow: '#cdcdcd',
      border: '#EFEFEF'
    }
  }
};



var Themes = {
  __proto__: null,
  dark: dark,
  chalk: chalk
};

const CSSBuilder = ({
  tags,
  onChange,
  inline,
  baseTheme: _baseTheme = 'chalk',
  themeOverride: _themeOverride = {},
  config,
  ...rest
}) => {
  const [allProps, setAllProps] = useState([]);
  const [showPropertyBorwser, setShowPropertyBorwser] = useState(false);
  const [selectedProperty, setSelectedProperty] = useState(-1);
  const [selectedIndex, setSelectedIndex] = useState(-1);
  const [finalTheme, setFinalTheme] = useState({});
  const [loading, setLoading] = useState(true);
  useEffect(() => {
    let defaultTheme = Themes[_baseTheme];
    const oTheme = _themeOverride;
    defaultTheme = Object.assign(defaultTheme, oTheme);
    setFinalTheme(defaultTheme);
    setLoading(false);
  }, [config]);

  const onRowAdd = () => {
    setSelectedProperty(allProps.length);
    setShowPropertyBorwser(true);
  };

  const onPropertyChange = value => {
    setShowPropertyBorwser(false);
    allProps[selectedProperty] = Templates.filter(f => {
      return f.name === value.name && f.propertyName === value.propertyName;
    })[0];
    allProps[selectedProperty].controls.forEach(c => {
      c.value = c.default ? c.default : '';
    });
    setAllProps(JSON.parse(JSON.stringify(allProps)));
    fireOnChange(allProps);
    setSelectedIndex(selectedProperty);
  };

  const onPropertyValueChange = (value, controlindex, rowindex) => {
    allProps[rowindex].controls[controlindex].value = `${allProps[rowindex].controls[controlindex].prefix || ''}${value}${allProps[rowindex].controls[controlindex].suffix || ''}`;
    setAllProps(allProps);
    fireOnChange(allProps);
  };

  const camelCase = input => {
    return input.toLowerCase().replace(/-(.)/g, function (match, group1) {
      return group1.toUpperCase();
    });
  };

  const fireOnChange = styles => {
    let resStyle = inline ? {} : '';
    styles.forEach(row => {
      if (Object.keys(row).length) {
        const styleName = inline ? camelCase(row.propertyName) : row.propertyName;
        let styleValue = row.valuetemplate || '${0}';
        row.controls.forEach((c, ci) => {
          styleValue = styleValue.replace(`{${ci}}`, c.value || '');
        });

        if (inline) {
          resStyle[styleName] = styleValue;
        } else {
          resStyle = `${resStyle}${styleName}:${styleValue};}`;
        }
      }
    });

    if (onChange) {
      onChange(resStyle);
    }
  };

  return /*#__PURE__*/createElement(Fragment, null, loading ? null : /*#__PURE__*/createElement(ThemeProvider, {
    theme: finalTheme
  }, /*#__PURE__*/createElement("div", {
    style: {
      height: '100%',
      display: 'flex',
      flexDirection: 'column'
    }
  }, /*#__PURE__*/createElement("div", {
    style: {
      height: '60px',
      padding: '1rem'
    }
  }, /*#__PURE__*/createElement(CBSimpleButton, {
    type: "button",
    value: "+ CSS attribute",
    onClick: () => onRowAdd(),
    style: {
      height: '40px'
    }
  })), /*#__PURE__*/createElement("div", {
    style: {
      overflow: 'auto',
      flex: 1
    }
  }, /*#__PURE__*/createElement(Accordion, {
    selectedIndex: selectedIndex,
    onChange: (index, expanded, si) => setSelectedIndex(si)
  }, allProps.map((prop, propi) => {
    return /*#__PURE__*/createElement("div", {
      "data-header": `${prop.display || 'No attribute selected'}`,
      "help-link": prop.link,
      "on-remove-clicked": () => {
        allProps.splice(propi, 1);
        setAllProps(JSON.parse(JSON.stringify(allProps)));
        fireOnChange(allProps);
      },
      "on-change-clicked": () => {
        setSelectedProperty(propi);
        setShowPropertyBorwser(true);
      }
    }, prop.controls.map((c, ci) => {
      return /*#__PURE__*/createElement("div", {
        style: {
          flex: 1
        },
        key: ci
      }, /*#__PURE__*/createElement("div", {
        style: {
          display: 'flex'
        }
      }, /*#__PURE__*/createElement(ControlTemplate, {
        field: c,
        onChange: val => {
          onPropertyValueChange(val, ci, propi);
        }
      })));
    }));
  }))), showPropertyBorwser ? /*#__PURE__*/createElement(PropertyBrowser, {
    show: showPropertyBorwser,
    onChange: val => onPropertyChange(val),
    onClose: () => setShowPropertyBorwser(false)
  }) : null)));
};

export { CSSBuilder };
//# sourceMappingURL=index.modern.js.map
